C-----------------------------------------------------------------------
      PROGRAM CONDPLET
C
C  THIS IS A B.E. PROGRAM THAT USES (CON)STANT ELEMENTS FOR THE SOLUTION
C  OF (D)YNAMIC (PL)ANE (E)LASTIC (T)IME DOMAIN PROBLEMS
C  PROGRAM NO.11
C
      PARAMETER(NX=100,NXM=50,NSTM=30,NFM=10,NPM=15)
      CHARACTER*12 FILEIN,FILEOUT,FILEAUX
      DIMENSION G(NX,NX),H(NX,NX),BC(NX),FI(NX),A1(NX,NX),B1(NX,NX),
     &          X(NXM+1),Y(NXM+1),XM(NXM),YM(NXM),KODE(NX),
     &          FUNC(NFM,NPM,2),IFUNC(NX),FSCALE(NFM),NPOIF(NFM),
     &          U(NX,NSTM),T(NX,NSTM),SL(NXM),ETAX(NXM),ETAY(NXM)
      COMMON/MATG/G
      COMMON/MATH/H
      COMMON/MATA/A1
      COMMON/MATB/B1
      COMMON/MATU/U
      COMMON/MATT/T
C
C  NX IS THE MAXIMUM DIMENSION OF THE SYSTEM OF EQUATIONS
C
C  ASSIGN NUMBERS FOR INPUT, OUTPUT AND AUXILIARY FILES
C
      INP=5
      IPR=6
      IAU=7
C
C  READ NAMES AND OPEN FILES FOR INPUT AND OUTPUT
C
      WRITE(*,' (A,$) ') ' NAME OF THE INPUT  FILE (MAX. 12 CHAR.)    :'
      READ(*,' (A) ') FILEIN
      OPEN(INP,FILE=FILEIN,STATUS='OLD')
      WRITE(*,' (A,$) ') ' NAME OF THE OUTPUT FILE (MAX. 12 CHAR.)    :'
      READ(*,' (A) ') FILEOUT
      OPEN(IPR,FILE=FILEOUT,STATUS='NEW')
      WRITE(*,' (A,$) ') ' NAME OF THE AUXILIARY FILE (MAX. 12 CHAR.) :'
      READ(*,' (A) ') FILEAUX
      OPEN(IAU,FILE=FILEAUX,STATUS='NEW',ACCESS='SEQUENTIAL',
     &     FORM='UNFORMATTED')
C
C  READ DATA
C
      CALL INPUT11(N,INTIMP,NSTEP,AT,GE,XNU,RO,X,Y,NPOIF,FSCALE,FUNC,
     &             KODE,BC,IFUNC,CP,CS,INP,IPR,NFM,NPM)
C
      DO 20 ISTEP=1,NSTEP
      PRINT *,ISTEP
C
C  FORM MATRICES G AND H OF STEP 'ISTEP'
C
      CALL GHMAT11(X,Y,XM,YM,G,H,KODE,N,NX,A1,B1,ISTEP,AT,GE,XNU,
     &             RO,CP,CS,IAU,SL,ETAX,ETAY)
C
C  FORM THE RIGHT HAND SIDE VECTOR ADDING THE BOUNDARY CONDITION
C  VECTOR AND THE PREVIOUS STEP EFFECT VECTOR
C
      CALL PREST11(G,H,B1,U,T,FI,BC,IFUNC,KODE,FSCALE,FUNC,NPOIF,
     &             ISTEP,AT,N,NX,IAU,NFM,NPM)
C
C  SOLVE SYSTEM OF EQUATIONS
C
      KKK=0
      IF(ISTEP.EQ.1) KKK=1
      CALL RSOLVER(A1,FI,2*N,NX,KKK)
C
C  PRINT RESULTS AT BOUNDARY NODE
C
      CALL OUTPUT11(XM,YM,FI,U,T,KODE,N,NX,ISTEP,INTIMP,AT*ISTEP,
     &IPR,GE)       
   20 CONTINUE
      CLOSE(INP)
      CLOSE(IPR)
      CLOSE(IAU)
      STOP
      END
C-----------------------------------------------------------------------
      SUBROUTINE INPUT11(N,INTIMP,NSTEP,AT,GE,XNU,RO,X,Y,NPOIF,FSCALE,
     &                   FUNC,KODE,BC,IFUNC,CP,CS,INP,IPR,NFM,NPM)
C
      CHARACTER*80 TITLE
      DIMENSION X(1),Y(1),NPOIF(1),FSCALE(1),FUNC(NFM,NPM,2),KODE(1),
     &          BC(1),IFUNC(1)
C
C  N =  NUMBER OF BOUNDARY NODES (= NUMBER OF ELEMENTS)
C  CP=  P-WAVE VELOCITY
C  CS=  S-WAVE VELOCITY
C  RO=  DENSITY
C  GE=  SHEAR MODULUS
C  XNU= POISSON MODULUS
C
C  READ JOB TITLE
C
      WRITE(IPR,'('' '',79(''*''))')
      READ(INP,'(A)') TITLE
      WRITE(IPR,'(A)') TITLE
C
C  READ GENERAL PARAMETERS
C
      READ(INP,*) N,NFUNC,INTIMP,NSTEP,AT,GE,XNU,RO
      IF(INTIMP.EQ.0) INTIMP=NSTEP+1
      CS=SQRT(GE/RO)
      CP=CS*SQRT((2.-2.*XNU)/(1.-2.*XNU))
      WRITE(IPR,100) N,NFUNC,INTIMP,NSTEP,AT,CP,CS,GE,XNU,RO
100   FORMAT(//'DATA'//2X,
     &       'NUMBER OF BOUNDARY ELEMENTS = ',I3/2X,
     &       'NUMBER OF TIME FUNCTIONS    = ',I3/2X,
     &       'INTERVAL OF PRINTING        = ',I3/2X,
     &       'NUMBER OF TIME STEPS        = ',I3/2X,
     &       'TIME INTERVAL               = ',E14.7/2X,
     &       'P-WAVE VELOCITY             = ',E14.7/2X,
     &       'S-WAVE VELOCITY             = ',E14.7/2X,
     &       'SHEAR MODULUS               = ',E14.7/2X,
     &       'POISSON RATIO               = ',E14.7/2X,
     &       'DENSITY                     = ',E14.7)
C
C  READ COORDINATES OF THE EXTREME POINTS OF THE BOUNDARY
C  ELEMENTS IN ARRAYS X AND Y
C
      WRITE(IPR,200)
  200 FORMAT(//2X,'COORDINATES OF THE EXTREME POINTS OF ',
     &       'THE BOUNDARY ELEMENTS'//4X,'POINT',10X,'X',18X,'Y')
      READ(INP,*) (X(I),Y(I),I=1,N)
      DO 10 I=1,N
   10 WRITE(IPR,300) I,X(I),Y(I)
  300 FORMAT(5X,I3,2(5X,E14.7))
C
C  READ TIME FUNCTIONS
C
      WRITE(IPR,400)
  400 FORMAT(//2X,'TIME FUNCTIONS')
      DO 20 I=1,NFUNC
      READ(INP,*) NPOIF(I),FSCALE(I)
   20 READ(INP,*) (FUNC(I,J,1),FUNC(I,J,2),J=1,NPOIF(I))
      DO 30 I=1,NFUNC
      WRITE(IPR,500) I,NPOIF(I),FSCALE(I)
   30 WRITE(IPR,600) (J,FUNC(I,J,1),FUNC(I,J,2),J=1,NPOIF(I))
  500 FORMAT(/2X,'FUNCTION NUMBER  = ',I3/2X,
     &       'NUMBER OF POINTS = ',I3/2X,
     &       'FUNCTION SCALE   = ',E14.7//4X,
     &       'POINT',8X,'TIME',11X,'VALUE')
  600 FORMAT(5X,I3,4X,E14.7,2X,E14.7)
C
C  READ BOUNDARY CONDITIONS IN BC(I) AND IFUNC(I) VECTORS;
C  IF KODE(I)=0 THE BC(I) VALUE IS A KNOWN DISPLACEMENT,
C  IF KODE(I)=1 THE BC(I) VALUE IS A KNOWN TRACTION
C  THE VALUE OF THE PRESCRIBED BOUNDARY CONDITIONS IN ANY STEP IS BC(I)
C  TIMES THE VALUE OF THE IFUNC(I) FUNCTION MULTIPLIED BY FSCALE(I)
C
      WRITE(IPR,700)
  700 FORMAT(//2X,'BOUNDARY CONDITIONS'//9X,'PRESCRIBED VALUE',15X,
     &       'PRESCRIBED VALUE'/3X,'NODE',5X,'X DIRECTION',4X,'CODE',1X,
     &       'FUNC.',7X,'Y DIRECTION',4X,'CODE',1X,'FUNC.')
      READ(INP,*) (KODE(2*I-1),BC(2*I-1),IFUNC(2*I-1),
     &             KODE(2*I),  BC(2*I),  IFUNC(2*I),  I=1,N)
      WRITE(IPR,800) (I,BC(2*I-1),KODE(2*I-1),IFUNC(2*I-1),
     &                  BC(2*I),  KODE(2*I),  IFUNC(2*I), I=1,N)
  800 FORMAT(3X,I3,4X,E14.7,5X,I1,3X,I2,7X,E14.7,5X,I1,3X,I2)
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE GHMAT11(X,Y,XM,YM,G,H,KODE,N,NX,A1,B1,ISTEP,AT,GE,XNU,
     &                   RO,CP,CS,IAU,SL,ETAX,ETAY)
C
C  THIS SUBROUTINE COMPUTES THE G AND H MATRICES AND
C  FORM THE MATRIX A1 OF THE SYSTEM OF EQUATIONS IN THE FIRST STEP
C
      PARAMETER(PI=3.1415926535)
      DIMENSION G(NX,1),H(NX,1),A1(NX,1),B1(NX,1),X(1),Y(1),XM(1),YM(1),
     &          KODE(1),SL(1),ETAX(1),ETAY(1),HT(2,2),GT(2,2)
C
C  COMPUTE NODAL COORDINATES AND ELEMENT PARAMETERS IN THE FIRST STEP
C
      IF(ISTEP.GT.1) GO TO 20
      X(N+1)=X(1)
      Y(N+1)=Y(1)
      DO 10 I=1,N
      XM(I)=(X(I)+X(I+1))/2.
      YM(I)=(Y(I)+Y(I+1))/2.
      SL(I)=SQRT((XM(I)-X(I))**2+(YM(I)-Y(I))**2)
      ETAX(I)=(YM(I)-Y(I))/SL(I)
   10 ETAY(I)=(X(I)-XM(I))/SL(I)
C
C  COMPUTE THE COEFFICIENTS OF G AND H MATRICES
C
   20 DO 60 I=1,N
      DO 60 J=1,N
      IF(I.EQ.J) GO TO 30
C
C  CHECK IF THE WAVES HAVE ARRIVED FORM THE I-NODE TO THE J-ELEMENT
C
      DIST=DISTC(XM(I),YM(I),X(J),Y(J),XM(J),YM(J),SL(J))
      IF(DIST.GT.CP*ISTEP*AT) GO TO 60
      CALL EXTIN11(XM(I),YM(I),X(J),Y(J),X(J+1),Y(J+1),SL(J),ETAX(J),
     &             ETAY(J),AT,ISTEP,CP,CS,XNU,GE,RO,GT,HT)
      GO TO 40
   30 CALL LOCIN11(SL(J),ETAX(J),ETAY(J),ISTEP,AT,RO,CP,CS,GT,HT)
      IF(ISTEP.GT.1) GO TO 40
C
C  ADD FREE TERM TO THE DIAGONAL AT THE FIRST STEP
C
      HT(1,1)=0.5
      HT(2,2)=0.5
   40 II=2*I-2
      JJ=2*J-2
      DO 50 K=1,2
      DO 50 L=1,2
      G(II+K,JJ+L)=GT(K,L)
   50 H(II+K,JJ+L)=HT(K,L)
   60 CONTINUE
C
C  WRITE THE MATRICES IN AN AUXILIARY FILE
C
      NN=2*N
      WRITE(IAU) ((H(I,J), I=1,NN), J=1,NN),((G(I,J), I=1,NN), J=1,NN)
C
C  REORDER THE COLUMNS OF THE SYSTEM OF EQUATIONS IN ACCORDANCE WITH THE
C  BOUNDARY CONDITIONS AND FORM SYSTEM MATRIX WHICH IS STORED IN A1 IN
C  THE FIRST STEP
C
      IF(ISTEP.GT.1) RETURN
      DO 110 J=1,NN
      IF(KODE(J)) 70,70,90
   70 DO 80 I=1,NN
      A1(I,J)=-G(I,J)*GE
   80 B1(I,J)=-H(I,J)
      GO TO 110
   90 DO 100 I=1,NN
      A1(I,J)=H(I,J)
  100 B1(I,J)=G(I,J)
  110 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE EXTIN11(XP,YP,X1,Y1,X2,Y2,SR,ETA1,ETA2,AT,ISTEP,CP,CS,
     &                   XNU,GE,RO,GT,HT)
C
C  THIS SUBROUTINE COMPUTES THE G AND H MATRICES
C  COEFFICIENTS THAT RELATE A COLOCATION POINT WITH AN ELEMENT
C  TO WHICH THE POINT DOES NOT BELONG USING GAUSS QUADRATURE
C
C  RA            = RADIUS
C  RD1,RD2,RDN   = RADIUS DERIVATIVES
C  ETA1,ETA2     = COMPONENTS OF THE UNIT NORMAL TO THE ELEMENT
C  GI(I)         = GAUSS QUADRATURE POINTS
C  OME(I)        = GAUSS QUADRATURE WEIGHTS
C  XCO,YCO       = INTEGRATION POINTS ALONG THE ELEMENT
C
      DIMENSION GI(10),OME(10),GT(2,2),HT(2,2)
      DATA GI /-.97390629,-.86506337,-.67940957,-.43339539,-.14887434,
     &          .14887434, .43339539, .67940957, .86506337, .97390629/
     &    OME / .06667134, .14945135, .21908636, .26926671, .29552422,
     &          .29552422, .26926671, .21908636, .14945135, .06667134/

      AX=(X2-X1)/2
      BX=(X2+X1)/2
      AY=(Y2-Y1)/2
      BY=(Y2+Y1)/2
      DO 10 I=1,2
      DO 10 J=1,2
      GT(I,J)=0.0
   10 HT(I,J)=0.0
      DO 20 I=1,10
      XCO=AX*GI(I)+BX-XP
      YCO=AY*GI(I)+BY-YP
      RA=SQRT(XCO**2+YCO**2)
      IF(RA.GT.CP*AT*ISTEP) GO TO 20
      RD1=XCO/RA
      RD2=YCO/RA
      RDN=RD1*ETA1+RD2*ETA2
      XJA=OME(I)*SR
      CALL FUNDSOLE(E1,E2,Z1,Z2,Z3,RA,ISTEP,AT,CP,CS,XNU,GE,RO)
      GT(1,1)=GT(1,1)+XJA*(E1-E2+2*RD1*RD1*E2)
      GT(1,2)=GT(1,2)+XJA*(2*RD1*RD2*E2)
      GT(2,2)=GT(2,2)+XJA*(E1-E2+2*RD2*RD2*E2)
      HT(1,1)=HT(1,1)+XJA*(RDN*(Z1+2.*RD1*RD1*Z2)+ETA1*RD1*(Z1+Z3))/RA
      HT(1,2)=HT(1,2)+XJA*(RDN*2.*RD1*RD2*Z2+ETA1*RD2*Z1+ETA2*RD1*Z3)/RA
      HT(2,1)=HT(2,1)+XJA*(RDN*2.*RD1*RD2*Z2+ETA1*RD2*Z3+ETA2*RD1*Z1)/RA
      HT(2,2)=HT(2,2)+XJA*(RDN*(Z1+2.*RD2*RD2*Z2)+ETA2*RD2*(Z1+Z3))/RA
   20 CONTINUE
      GT(2,1)=GT(1,2)
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE LOCIN11(SR,ETA1,ETA2,ISTEP,AT,RO,CP,CS,GT,HT)
C
C  THIS SUBROUTINE COMPUTES ANALITICALLY THE VALUE OF THE MATRIX G
C  COEFFICIENTS THAT RELATE AN ELEMENT WITH ITSELF
C
      PARAMETER(PI=3.1415926535)
      DIMENSION GT(2,2),HT(2,2)
      RAIZ(A)=SQRT(A*A-1.0)
      DO 10 I=1,2
      DO 10 J=1,2
   10 HT(I,J)=0.0
      TIME0=ISTEP*AT
      TIME1=(ISTEP-1)*AT
      P0=AMAX1(1.0,CP*TIME0/SR)
      P1=AMAX1(1.0,CP*TIME1/SR)
      S0=AMAX1(1.0,CS*TIME0/SR)
      S1=AMAX1(1.0,CS*TIME1/SR)
      RAIZ0=RAIZ(P0)+P0/S0*RAIZ(S0)
      RAIZ1=RAIZ(P1)+P1/S1*RAIZ(S1)
      A_CT=(TIME0*(ALOG(P0+RAIZ(P0))/P0+ASIN(1.0/P0))-
     &      TIME1*(ALOG(P1+RAIZ(P1))/P1+ASIN(1.0/P1)))/CP+
     &     (TIME0*(ALOG(S0+RAIZ(S0))/S0+ASIN(1.0/S0))-
     &      TIME1*(ALOG(S1+RAIZ(S1))/S1+ASIN(1.0/S1)))/CS
      B_CT=(TIME0*ASIN(1.0/P0)-TIME1*ASIN(1.0/P1))/CP-
     &     (TIME0*ASIN(1.0/S0)-TIME1*ASIN(1.0/S1))/CS
      IF(P0.GT.1.0) B_CT=B_CT-TIME0/CP*(1.0-(P0/S0)**2)/RAIZ0
      IF(P1.GT.1.0) B_CT=B_CT+TIME1/CP*(1.0-(P1/S1)**2)/RAIZ1
      GLOCAL11=(A_CT-B_CT)/2.0/PI/RO
      GLOCAL22=(A_CT+B_CT)/2.0/PI/RO
      GT(1,1)=GLOCAL11*ETA2**2+GLOCAL22*ETA1**2
      GT(1,2)=(GLOCAL22-GLOCAL11)*ETA1*ETA2
      GT(2,2)=GLOCAL11*ETA1**2+GLOCAL22*ETA2**2
      GT(2,1)=GT(1,2)
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE FUNDSOLE(E1,E2,Z1,Z2,Z3,RA,ISTEP,AT,CP,CS,XNU,GE,RO)
C
C  THIS SUBROUTINE COMPUTES THE FUNDAMENTAL SOLUTION COMPONENTS
C
      PARAMETER(PI=3.1415926535)
      ACOSH(X)=ALOG(X+SQRT(X**2-1.0))
      RAIS(X)=SQRT(X*X-1.0)/X
C
      E1=0.0
      E2=0.0
      Z1=0.0
      Z2=0.0
      Z3=0.0
      P0=CP*ISTEP*AT/RA
      IF(P0.LE.1.0) RETURN
      P1=AMAX1(1.0,CP*(ISTEP-1)*AT/RA)
      P2=AMAX1(1.0,CP*(ISTEP-2)*AT/RA)
      S0=AMAX1(1.0,CS*ISTEP*AT/RA)
      S1=AMAX1(1.0,CS*(ISTEP-1)*AT/RA)
      S2=AMAX1(1.0,CS*(ISTEP-2)*AT/RA)
      CPS=2.0*(1.0-XNU)/(1.0-2.0*XNU)
      PS0=(P0/S0)**2-1.0
      PS1=(P1/S1)**2-1.0
      PS2=(P2/S2)**2-1.0
      RAIS0=RAIS(P0)+RAIS(S0)
      RAIS1=RAIS(P1)+RAIS(S1)
      RAIS2=RAIS(P2)+RAIS(S2)
      CTE=1./4./PI/RO/CP/CP
      E1=CTE*((ACOSH(P0)-ACOSH(P1))+CPS*(ACOSH(S0)-ACOSH(S1)))
      E2=CTE*PS0/RAIS0
      IF(P1.GT.1.0) E2=E2-CTE*PS1/RAIS1
      V1=     ISTEP/3.*(RAIS(P0)*RAIS0+RAIS(S0)**2)*PS0/RAIS0
      IF(P1.GT.1.0) V1=V1-
     &  2*(ISTEP-1)/3.*(RAIS(P1)*RAIS1+RAIS(S1)**2)*PS1/RAIS1
      IF(P2.GT.1.0) V1=V1+
     &    (ISTEP-2)/3.*(RAIS(P2)*RAIS2+RAIS(S2)**2)*PS2/RAIS2
      V2=ISTEP*RAIS(P0)/2.-(ISTEP-1)*RAIS(P1)+(ISTEP-2)*RAIS(P2)/2.
      V3=ISTEP*RAIS(S0)/2.-(ISTEP-1)*RAIS(S1)+(ISTEP-2)*RAIS(S2)/2.
      CTZ=4.0*GE*CTE
      Z1=CTZ*(V1-CPS*V3)
      Z2=CTZ*(-2.0*V1-(V2-CPS*V3))
      Z3=CTZ*(V1-2.0*XNU/(1.0-2.0*XNU)*V2)
      RETURN
      END
C-----------------------------------------------------------------------
      FUNCTION DISTC(XP,YP,X1,Y1,X2,Y2,SR)
      PROY=ABS((X2-X1)*(X2-XP)+(Y2-Y1)*(Y2-YP))/SR
      DIST=SQRT((X2-XP)**2+(Y2-YP)**2)
      IF(SR-PROY) 10,20,20
   10 DISTC=SQRT(DIST**2-SR*(2*PROY-SR))
      RETURN
   20 DISTC=SQRT(DIST**2-PROY**2)
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE PREST11(G,H,B1,U,T,FI,BC,IFUNC,KODE,FSCALE,FUNC,NPOIF,
     &                   ISTEP,AT,N,NX,IAU,NFM,NPM)
C
C  THIS SUBROUTINE ADDS THE CONTRIBUTION OF PREVIOUS STEPS AND THE
C  CONTRIBUTION OF BOUNDARY CONDITION TO FORM THE RIGHT HAND SIDE VECTOR
C
      DIMENSION G(NX,1),H(NX,1),B1(NX,1),U(NX,1),T(NX,1),FI(1),BC(1),
     &          IFUNC(1),KODE(1),FSCALE(1),FUNC(NFM,NPM,2),NPOIF(1)

      NN=2*N
      DO 10 J=1,NN
   10 FI(J)=0.0
      TIME=ISTEP*AT
      DO 30 J=1,NN
      NF=IFUNC(J)
      BCVALUE=FUNCVAL(NF,TIME,BC(J)*FSCALE(NF),NPOIF(NF),FUNC,NFM,NPM)
      IF(KODE(J).EQ.0) U(J,ISTEP)=BCVALUE
      IF(KODE(J).EQ.1) T(J,ISTEP)=BCVALUE
      IF(BCVALUE.EQ.0.0) GO TO 30
      DO 20 I=1,NN
   20 FI(I)=FI(I)+B1(I,J)*BCVALUE
   30 CONTINUE
      IF(ISTEP.EQ.1) RETURN
      REWIND IAU
      READ(IAU)
      DO 50 IMAT=2,ISTEP
      READ(IAU) ((H(I,J),I=1,NN),J=1,NN),((G(I,J),I=1,NN),J=1,NN)
      IUT=ISTEP-IMAT+1
      DO 50 J=1,NN
      AUXU=U(J,IUT)
      AUXT=T(J,IUT)
      IF(AUXT.EQ.0.0.AND.AUXU.EQ.0.0) GO TO 50
      DO 40 I=1,NN
   40 FI(I)=FI(I)+G(I,J)*AUXT-H(I,J)*AUXU
   50 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      FUNCTION FUNCVAL(NF,TT,SCALE,NPOIN,FUNC,NFM,NPM)
      DIMENSION FUNC(NFM,NPM,2)
      FUNCVAL=FUNC(NF,1,2)*SCALE
      IF(SCALE.EQ.0.0) RETURN
      DO 10 I=1,NPOIN-1
      IF(TT.LT.FUNC(NF,I,1).OR.TT.GE.FUNC(NF,I+1,1)) GO TO 10
      FUNCVAL=SCALE*(FUNC(NF,I,2)+(FUNC(NF,I+1,2)-FUNC(NF,I,2))/
     &        (FUNC(NF,I+1,1)-FUNC(NF,I,1))*(TT-FUNC(NF,I,1)))
      RETURN
   10 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE OUTPUT11(XM,YM,FI,U,T,KODE,N,NX,ISTEP,INTIMP,TIME,IPR,
     &                   GE)
C
C  THIS SUBROUTINE PRINTS THE VALUES OF THE DISPLACEMENTS AND
C  TRACTIONS AT BOUNDARY NODES. IT ALSO PUTS THE CALCULATED VALUES AND
C  BOUNDARY CONDITION IN THEIR CORRESPONDING VECTORS
C
      DIMENSION FI(1),XM(1),YM(1),U(NX,1),T(NX,1),KODE(1)
C
      NN=2*N
      DO 10 I=1,NN
      IF(KODE(I).EQ.0) T(I,ISTEP)=FI(I)*GE
   10 IF(KODE(I).EQ.1) U(I,ISTEP)=FI(I)
      IF((ISTEP/INTIMP)*INTIMP.NE.ISTEP.AND.ISTEP.NE.1) RETURN
      WRITE(IPR,100) TIME
      DO 20 I=1,N
   20 WRITE(IPR,200) XM(I),YM(I),U(2*I-1,ISTEP),U(2*I,ISTEP),
     &               T(2*I-1,ISTEP),T(2*I,ISTEP)
C
  100 FORMAT(' ',79('*')//' RESULTS AT TIME = ',E12.5//
     &       '  BOUNDARY NODES'//6X,'X',12X,'Y',9X,'DISPL. X',5X,
     &       'DISPL. Y',4X,'TRACTION X',3X,'TRACTION Y'/)
  200 FORMAT(6(1X,E12.5))
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE RSOLVER(A,B,N,NX,KKK)
C
      REAL A(NX,NX),B(NX),X,RDOT
C
C  A=L*U  FACTORIZATION
C
C  KKK=0 : ONLY FORWARD AND BACK SUSTITUTION
C  KKK=1 : FACTORIZATION AND FORWARD AND BACK SUSTITUTION
C
      IF(KKK.EQ.0) GO TO 30
      DO 20 K=1,N
      K1=K-1
      DO 10 I=K,N
   10 A(I,K)=A(I,K)-RDOT(K1,A(I,1),NX,A(1,K),1)
      X=A(K,K)
      IF(X.NE.0.) GOTO 15
      WRITE(6,*) ' SOLVER : STOP  SINGULARITY IN ROW ',K
      STOP ' SOLVER : STOP SINGULARITY '
   15 X=1./X
      DO 20 J=K+1,N
   20 A(K,J)=X*(A(K,J)-RDOT(K1,A(K,1),NX,A(1,J),1))
   30 CONTINUE
C
C  FORWARD AND BACK SUBSTITUTION    L*U*X=B
C
C  SOLVE  L*Y=B
C
      DO 40 I=1,N
      B(I)=-(RDOT((I-1),A(I,1),NX,B,1)+B(I))/A(I,I)
   40 CONTINUE
C
C  SOLVE  U*X=Y
C
      DO 50 I=N,1,-1
      B(I)=-(RDOT((N-I),A(I,I+1),NX,B(I+1),1)+B(I))
   50 CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      FUNCTION RDOT(N,U,IUX,V,IVX)
C
C THIS FUNCTION MAKES THE REAL DOT PRODUCT OF TWO VECTORS
C
      REAL U(1),V(1)
C
      RDOT=0.
      IF(N.LE.0) RETURN
      IU=1
      IV=1
      IF(IUX.LT.0) IU=1-(N-1)*IUX
      IF(IVX.LT.0) IV=1-(N-1)*IVX
      DO 10 I=1,N
      RDOT=RDOT+U(IU)*V(IV)
      IU=IU+IUX
   10 IV=IV+IVX
      RETURN
      END
