C ----------------------------------------------------------------------
      PROGRAM CONDPLST
C
C  THIS IS A B.E. PROGRAM THAT USES (CON)STANT ELEMENTS FOR THE SOLUTION
C  OF (D)YNAMIC (PL)ANE (S)CALAR (T)IME DOMAIN PROBLEMS
C  PROGRAN N0. 9
C
      PARAMETER(NX=50,NSTM=30,NFM=10,NPM=15)
      CHARACTER*12 FILEIN,FILEOUT,FILEAUX
      DIMENSION G(NX,NX),H(NX,NX),BC(NX),FI(NX),A1(NX,NX),B1(NX,NX),
     &          X(NX+1),Y(NX+1),XM(NX),YM(NX),KODE(NX),FUNC(NFM,NPM,2),
     &          IFUNC(NX),FSCALE(NFM),NPOIF(NFM),U(NX,NSTM),T(NX,NSTM),
     &          SL(NX),ETAX(NX),ETAY(NX)
      COMMON/MATG/G
      COMMON/MATH/H
      COMMON/MATA/A1
      COMMON/MATB/B1
      COMMON/MATU/U
      COMMON/MATT/T
C
C  NX IS THE MAXIMUM DIMENSION OF THE SYSTEM OF EQUATIONS
C
C  ASSIGN NUMBERS FOR INPUT, OUTPUT AND AUXILIARY FILES
C
      INP=5
      IPR=6
      IAU=7
C
C  READ NAMES AND OPEN FILES FOR INPUT AND OUTPUT
C
      WRITE(*,' (A,$) ') ' NAME OF THE INPUT  FILE (MAX. 12 CHAR.)    :'
      READ(*,' (A) ') FILEIN
      OPEN(INP,FILE=FILEIN,STATUS='OLD')
      WRITE(*,' (A,$) ') ' NAME OF THE OUTPUT FILE (MAX. 12 CHAR.)    :'
      READ(*,' (A) ') FILEOUT
      OPEN(IPR,FILE=FILEOUT,STATUS='NEW')
      WRITE(*,' (A,$) ') ' NAME OF THE AUXILIARY FILE (MAX. 12 CHAR.) :'
      READ(*,' (A) ') FILEAUX
      OPEN(IAU,FILE=FILEAUX,STATUS='NEW',ACCESS='SEQUENTIAL',
     &     FORM='UNFORMATTED')
C
C  READ DATA
C
      CALL INPUT9(N,INTIMP,NSTEP,AT,X,Y,NPOIF,FSCALE,FUNC,KODE,BC,
     &            IFUNC,CS,INP,IPR,NFM,NPM)
C
      DO 20 ISTEP=1,NSTEP
      PRINT *,ISTEP
C
C  FORM MATRICES G AND H OF STEP 'ISTEP'
C
      CALL GHMAT9(X,Y,XM,YM,G,H,KODE,N,NX,A1,B1,ISTEP,AT,CS,IAU,SL,
     &            ETAX,ETAY)
C
C  FORM THE RIGHT HAND SIDE VECTOR ADDING THE BOUNDARY CONDITION
C  VECTOR AND THE PREVIOUS STEP EFFECT VECTOR
C
      CALL PREST9(G,H,B1,U,T,FI,BC,IFUNC,KODE,FSCALE,FUNC,NPOIF,N,
     &            ISTEP,AT,IAU,NX,NFM,NPM)
C
C  SOLVE SYSTEM OF EQUATIONS
C
      KKK=0
      IF(ISTEP.EQ.1) KKK=1
      CALL RSOLVER(A1,FI,N,NX,KKK)
C
C  PRINT RESULTS AT BOUNDARY NODE
C
      CALL OUTPUT9(XM,YM,FI,U,T,KODE,N,NX,ISTEP,INTIMP,AT*ISTEP,IPR)
   20 CONTINUE
      CLOSE(INP)
      CLOSE(IPR)
      CLOSE(IAU)
      STOP
      END
C-----------------------------------------------------------------------
      SUBROUTINE INPUT9(N,INTIMP,NSTEP,AT,X,Y,NPOIF,FSCALE,FUNC,KODE,BC,
     &                  IFUNC,CS,INP,IPR,NFM,NPM)
C
      CHARACTER*80 TITLE
      DIMENSION X(1),Y(1),NPOIF(1),FSCALE(1),FUNC(NFM,NPM,2),KODE(1),
     &          BC(1),IFUNC(1)
C
C  N =  NUMBER OF BOUNDARY NODES (= NUMBER OF ELEMENTS)
C  CS=  WAVE VELOCITY
C
C  READ JOB TITLE
C
      WRITE(IPR,'('' '',79(''*''))')
      READ(INP,'(A)') TITLE
      WRITE(IPR,'(A)') TITLE
C
C  READ GENERAL PARAMETERS
C
      READ(INP,*) N,NFUNC,INTIMP,NSTEP,AT,CS
      IF(INTIMP.EQ.0) INTIMP=NSTEP+1
      WRITE(IPR,100) N,NFUNC,INTIMP,NSTEP,AT,CS
100   FORMAT(//' DATA'//2X,
     &       'NUMBER OF BOUNDARY ELEMENTS = ',I3/2X,
     &       'NUMBER OF TIME FUNCTIONS    = ',I3/2X,
     &       'INTERVAL OF PRINTING        = ',I3/2X,
     &       'NUMBER OF TIME STEPS        = ',I3/2X,
     &       'TIME INTERVAL               = ',E14.7/2X,
     &       'WAVE VELOCITY               = ',E14.7)
C
C  READ COORDINATES OF THE EXTREME POINTS OF THE BOUNDARY
C  ELEMENTS IN ARRAYS X AND Y
C
      WRITE(IPR,200)
  200 FORMAT(//2X,'COORDINATES OF THE EXTREME POINTS OF ',
     &       'THE BOUNDARY ELEMENTS'//4X,'POINT',10X,'X',18X,'Y')
      READ(INP,*) (X(I),Y(I),I=1,N)
      DO 10 I=1,N
   10 WRITE(IPR,300) I,X(I),Y(I)
  300 FORMAT(5X,I3,2(5X,E14.7))
C
C  READ TIME FUNCTIONS
C
      WRITE(IPR,400)
  400 FORMAT(//2X,'TIME FUNCTIONS')
      DO 20 I=1,NFUNC
      READ(INP,*) NPOIF(I),FSCALE(I)
   20 READ(INP,*) (FUNC(I,J,1),FUNC(I,J,2),J=1,NPOIF(I))
      DO 30 I=1,NFUNC
      WRITE(IPR,500) I,NPOIF(I),FSCALE(I)
      DO 30 J=1,NPOIF(I)
   30 WRITE(IPR,600) J,FUNC(I,J,1),FUNC(I,J,2)
  500 FORMAT(/2X,'FUNCTION NUMBER  = ',I3/2X,
     &       'NUMBER OF POINTS = ',I3/2X,
     &       'FUNCTION SCALE   = ',E14.7/4X,
     &       'POINT',8X,'TIME',11X,'VALUE')
  600 FORMAT(5X,I3,4X,E14.7,2X,E14.7)
C
C  READ BOUNDARY CONDITIONS IN BC(I) AND IFUNC(I) VECTORS;
C  IF KODE(I)=0 THE BC(I) VALUE IS A KNOWN POTENTIAL,
C  IF KODE(I)=1 THE BC(I) VALUE IS A KNOWN FLUX
C  THE VALUE OF THE PRESCRIBED BOUNDARY CONDITIONS IN ANY STEP IS BC(I)
C  TIMES THE VALUE OF THE IFUNC(I) FUNCTION MULTIPLIED BY FSCALE(I)
C
      WRITE(IPR,700)
  700 FORMAT(//2X,'BOUNDARY CONDITIONS'//
     &       3X,'NODE',3X,'PRESCRIBED VALUE',2X,'CODE',2X,'FUNCTION')
      READ(INP,*) (KODE(I),BC(I),IFUNC(I),I=1,N)
      WRITE(IPR,800) (I,BC(I),KODE(I),IFUNC(I),I=1,N)
  800 FORMAT(2X,I3,4X,E14.7,7X,I1,8X,I1)
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE GHMAT9(X,Y,XM,YM,G,H,KODE,N,NX,A1,B1,ISTEP,AT,CS,IAU,
     &                  SL,ETAX,ETAY)
C
C  THIS SUBROUTINE COMPUTES THE G AND H MATRICES AND
C  FORM THE MATRIX A1 OF THE SYSTEM OF EQUATIONS IN THE FIRST STEP
C
      DIMENSION G(NX,1),H(NX,1),A1(NX,1),B1(NX,1),X(1),Y(1),XM(1),
     &          YM(1),KODE(1),SL(1),ETAX(1),ETAY(1)
C
C  COMPUTE NODAL COORDINATES AND ELEMENT PARAMETERS IN THE FIRST STEP
C
      IF(ISTEP.GT.1) GO TO 20
      X(N+1)=X(1)
      Y(N+1)=Y(1)
      DO 10 I=1,N
      XM(I)=(X(I)+X(I+1))/2.
      YM(I)=(Y(I)+Y(I+1))/2.
      SL(I)=SQRT((XM(I)-X(I))**2+(YM(I)-Y(I))**2)
      ETAX(I)=(YM(I)-Y(I))/SL(I)
   10 ETAY(I)=(X(I)-XM(I))/SL(I)
C
C  COMPUTE THE COEFFICIENTS OF G AND H MATRICES
C
   20 DO 40 I=1,N
      DO 40 J=1,N
      H(I,J)=0.0
      G(I,J)=0.0
      IF(I.EQ.J) GO TO 30
C
C  CHECK IF THE WAVES HAVE ARRIVED FORM THE I-NODE TO THE J-ELEMENT
C
      DIST=DISTC(XM(I),YM(I),X(J),Y(J),XM(J),YM(J),SL(J))
      IF(DIST.GT.CS*AT*ISTEP) GO TO 40
      CALL EXTIN9(XM(I),YM(I),X(J),Y(J),X(J+1),Y(J+1),SL(J),ETAX(J),
     &            ETAY(J),ISTEP,AT,CS,G(I,J),H(I,J))
      GO TO 40
   30 CALL LOCIN9(G(I,J),CS*ISTEP*AT,CS*(ISTEP-1)*AT,SL(J))
      IF(ISTEP.EQ.1) H(I,I)=0.5
   40 CONTINUE
C
C  WRITE THE MATRICES IN AN AUXILIARY FILE
C
      WRITE(IAU) ((H(I,J),I=1,N),J=1,N),((G(I,J),I=1,N),J=1,N)
C
C  REORDER THE COLUMNS OF THE SYSTEM OF EQUATIONS IN ACCORDANCE WITH THE
C  BOUNDARY CONDITIONS AND FORM SYSTEM MATRIX WHICH IS STORED IN A1 IN
C  THE FIRST STEP
C
      IF(ISTEP.GT.1) RETURN
      DO 90 J=1,N
      IF(KODE(J)) 50,50,70
   50 DO 60 I=1,N
      A1(I,J)=-G(I,J)
   60 B1(I,J)=-H(I,J)
      GO TO 90
   70 DO 80 I=1,N
      A1(I,J)=H(I,J)
   80 B1(I,J)=G(I,J)
   90 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE EXTIN9(XP,YP,X1,Y1,X2,Y2,SL,ETA1,ETA2,ISTEP,AT,CS,
     &                  GG,HH)
C
C  THIS SUBROUTINE COMPUTES THE G AND H MATRICES
C  COEFFICIENTS THAT RELATE A COLOCATION POINT WITH AN ELEMENT
C  TO WHICH THE POINT DOES NOT BELONG USING GAUSS QUADRATURE
C
C  RA            = RADIUS
C  RDN           = RADIUS DERIVATIVE
C  ETA1,ETA2     = COMPONENTS OF THE UNIT NORMAL TO THE ELEMENT
C  GI(I)         = GAUSS QUADRATURE POINTS
C  OME(I)        = GAUSS QUADRATURE WEIGHTS
C  XCO,YCO       = INTEGRATION POINTS ALONG THE ELEMENT
C
      DIMENSION GI(10),OME(10)
      DATA GI /-.97390629,-.86506337,-.67940957,-.43339539,-.14887434,
     &          .14887434, .43339539, .67940957, .86506337, .97390629/
     &    OME / .06667134, .14945135, .21908636, .26926671, .29552422,
     &          .29552422, .26926671, .21908636, .14945135, .06667134/
C
      AX=(X2-X1)/2.0
      BX=(X2+X1)/2.0
      AY=(Y2-Y1)/2.0
      BY=(Y2+Y1)/2.0
      CST=CS*AT*ISTEP
      DO 40 I=1,10
      XCO=AX*GI(I)+BX-XP
      YCO=AY*GI(I)+BY-YP
      RA=SQRT(XCO**2+YCO**2)
      IF(RA.GT.CST) GO TO 40
      RDN=(XCO*ETA1+YCO*ETA2)/RA
      XJA=OME(I)*SL
      CALL FUNDSOLS(G,H,RA,ISTEP,AT,CS)
      GG=GG+XJA*G
      HH=HH+XJA*RDN*H
   40 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE LOCIN9(G,CT0,CT1,SL)
C
C  THIS SUBROUTINE COMPUTES THE VALUE OF THE MATRIX G COEFFICIENTS
C  THAT RELATE AN ELEMENT WITH ITSELF
C
      PARAMETER(PI=3.1415926535)
      ACOSH(X)=ALOG(X+SQRT(X*X-1.0))
C
      RS0=AMAX1(1.0,CT0/SL)
      RS1=AMAX1(1.0,CT1/SL)
      G=CT0*(ACOSH(RS0)/RS0+ASIN(1.0/RS0))/PI-
     &  CT1*(ACOSH(RS1)/RS1+ASIN(1.0/RS1))/PI
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE FUNDSOLS(G,H,RA,ISTEP,AT,CS)
C
C  THIS SUBROUTINE COMPUTES THE FUNDAMENTAL SOLUTION
C
      PARAMETER(PI2=6.2831853072)
      RAIZ(X)=SQRT(X*X-1.0)
C
      G=0.0
      H=0.0
      A0=CS*ISTEP*AT/RA
      IF(A0.LE.1.0) RETURN
      A1=CS*(ISTEP-1)*AT/RA
      A2=CS*(ISTEP-2)*AT/RA
      IF(A1.GT.1.0) GO TO 10
      G=ALOG(A0+RAIZ(A0))/PI2
      H=-RAIZ(A0)/PI2/CS/AT
      RETURN
   10 IF(A2.GT.1.0) GO TO 20
      G=ALOG((A0+RAIZ(A0))/(A1+RAIZ(A1)))/PI2
      H=-((2-ISTEP)*(3*ISTEP-2)*(CS*AT/RA)**2+3.0)/
     &   (RAIZ(A0)+2.0*RAIZ(A1))/PI2/CS/AT
      RETURN
   20 G=ALOG((A0+RAIZ(A0))/(A1+RAIZ(A1)))/PI2
      H=-(2.0-2.0*(A0**2+A2**2-1.0)/(RAIZ(A0)*RAIZ(A2)+A0*A2))/
     &   (RAIZ(A0)+2.0*RAIZ(A1)+RAIZ(A2))/PI2/CS/AT
      RETURN
      END
C-----------------------------------------------------------------------
      FUNCTION DISTC(XP,YP,X1,Y1,X2,Y2,SR)
      PROY=ABS((X2-X1)*(X2-XP)+(Y2-Y1)*(Y2-YP))/SR
      DIST=SQRT((X2-XP)**2+(Y2-YP)**2)
      IF(SR-PROY) 10,20,20
   10 DISTC=SQRT(DIST**2-SR*(2*PROY-SR))
      RETURN
   20 DISTC=SQRT(DIST**2-PROY**2)
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE PREST9(G,H,B1,U,T,FI,BC,IFUNC,KODE,FSCALE,FUNC,NPOIF,
     &                  N,ISTEP,AT,IAU,NX,NFM,NPM)
C
C  THIS SUBROUTINE ADDS THE CONTRIBUTION OF PREVIOUS STEPS AND THE
C  CONTRIBUTION OF BOUNDARY CONDITION TO FORM THE RIGHT HAND SIDE VECTOR
C
      DIMENSION G(NX,1),H(NX,1),B1(NX,1),U(NX,1),T(NX,1),FI(1),BC(1),
     &          IFUNC(1),KODE(1),FSCALE(1),FUNC(NFM,NPM,2),NPOIF(1)

      DO 10 J=1,N
   10 FI(J)=0.0
      TIME=AT*ISTEP
      DO 30 J=1,N
      NF=IFUNC(J)
      BCVALUE=FUNCVAL(NF,TIME,BC(J)*FSCALE(NF),NPOIF(NF),FUNC,NFM,NPM)
      IF(KODE(J).EQ.0) U(J,ISTEP)=BCVALUE
      IF(KODE(J).EQ.1) T(J,ISTEP)=BCVALUE
      IF(BCVALUE.EQ.0.0) GO TO 30
      DO 20 I=1,N
   20 FI(I)=FI(I)+B1(I,J)*BCVALUE
   30 CONTINUE
      IF(ISTEP.EQ.1) RETURN
      REWIND IAU
      READ(IAU)
      DO 50 IMAT=2,ISTEP
      READ(IAU) ((H(I,J), I=1,N), J=1,N),((G(I,J), I=1,N), J=1,N)
      IUT=ISTEP-IMAT+1
      DO 50 J=1,N
      AUXU=U(J,IUT)
      AUXT=T(J,IUT)
      IF(AUXU.EQ.0.0.AND.AUXT.EQ.0.0) GO TO 50
      DO 40 I=1,N
   40 FI(I)=FI(I)+G(I,J)*AUXT-H(I,J)*AUXU
   50 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      FUNCTION FUNCVAL(NF,TT,SCALE,NPOIN,FUNC,NFM,NPM)
      DIMENSION FUNC(NFM,NPM,2)
      FUNCVAL=FUNC(NF,1,2)*SCALE
      IF(SCALE.EQ.0.0) RETURN
      DO 10 I=1,NPOIN-1
      IF(TT.LT.FUNC(NF,I,1).OR.TT.GE.FUNC(NF,I+1,1)) GO TO 10
      FUNCVAL=SCALE*(FUNC(NF,I,2)+(FUNC(NF,I+1,2)-FUNC(NF,I,2))/
     &        (FUNC(NF,I+1,1)-FUNC(NF,I,1))*(TT-FUNC(NF,I,1)))
      RETURN
   10 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE OUTPUT9(XM,YM,FI,U,T,KODE,N,NX,ISTEP,INTIMP,TIME,IPR)
C
C  THIS SUBROUTINE PRINTS THE VALUES OF THE DISPLACEMENTS AND
C  TRACTIONS AT BOUNDARY NODES. IT ALSO PUTS THE CALCULATED VALUES AND
C  BOUNDARY CONDITION IN THEIR CORRESPONDING VECTORS
C
      DIMENSION FI(1),XM(1),YM(1),U(NX,1),T(NX,1),KODE(1)
C
      DO 10 I=1,N
      IF(KODE(I).EQ.0) T(I,ISTEP)=FI(I)
   10 IF(KODE(I).EQ.1) U(I,ISTEP)=FI(I)
      IF((ISTEP/INTIMP)*INTIMP.NE.ISTEP.AND.ISTEP.NE.1) RETURN
      WRITE(IPR,100) TIME
      DO 20 I=1,N
   20 WRITE(IPR,200) XM(I),YM(I),U(I,ISTEP),T(I,ISTEP)
  100 FORMAT(' ',79('*')//' RESULTS AT TIME = ',E12.5//
     &       '  BOUNDARY NODES'//8X,'X',15X,'Y',13X,'POTENTIAL',3X,
     &       'POTENTIAL DERIVATIVE'/)
  200 FORMAT(4(2X,E14.5))
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE RSOLVER(A,B,N,NX,KKK)
C
      REAL A(NX,NX),B(NX),X,RDOT
C
C  A=L*U  FACTORIZATION
C
C  KKK=0 : ONLY FORWARD AND BACK SUSTITUTION
C  KKK=1 : FACTORIZATION AND FORWARD AND BACK SUSTITUTION
C
      IF(KKK.EQ.0) GO TO 30
      DO 20 K=1,N
      K1=K-1
      DO 10 I=K,N
   10 A(I,K)=A(I,K)-RDOT(K1,A(I,1),NX,A(1,K),1)
      X=A(K,K)
      IF(X.NE.0.) GOTO 15
      WRITE(6,*) ' SOLVER : STOP  SINGULARITY IN ROW ',K
      STOP ' SOLVER : STOP SINGULARITY '
   15 X=1./X
      DO 20 J=K+1,N
   20 A(K,J)=X*(A(K,J)-RDOT(K1,A(K,1),NX,A(1,J),1))
   30 CONTINUE
C
C  FORWARD AND BACK SUBSTITUTION    L*U*X=B
C
C  SOLVE  L*Y=B
C
      DO 40 I=1,N
      B(I)=-(RDOT((I-1),A(I,1),NX,B,1)+B(I))/A(I,I)
   40 CONTINUE
C
C  SOLVE  U*X=Y
C
      DO 50 I=N,1,-1
      B(I)=-(RDOT((N-I),A(I,I+1),NX,B(I+1),1)+B(I))
   50 CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      FUNCTION RDOT(N,U,IUX,V,IVX)
C
C THIS FUNCTION MAKES THE REAL DOT PRODUCT OF TWO VECTORS
C
      REAL U(1),V(1)
C
      RDOT=0.
      IF(N.LE.0) RETURN
      IU=1
      IV=1
      IF(IUX.LT.0) IU=1-(N-1)*IUX
      IF(IVX.LT.0) IV=1-(N-1)*IVX
      DO 10 I=1,N
      RDOT=RDOT+U(IU)*V(IV)
      IU=IU+IUX
   10 IV=IV+IVX
      RETURN
      END
