C-----------------------------------------------------------------------
      PROGRAM QUADPLET
C
C  THIS IS A B.E. PROGRAM THAT USES (QUA)DRATIC ELEMENTS FOR THE
C  SOLUTION OF (D)YNAMIC (PL)ANE (E)LASTIC (T)IME DOMAIN PROBLEMS
C  PROGRAM NO.12
C
      PARAMETER(NX=64,NX1=(3*NX)/2,NSTM=30,NFM=10,NPM=15)
      CHARACTER*12 FILEIN,FILEOUT,FILEAUX
      DIMENSION G(NX,NX1),H(NX,NX),BC(NX1),FI(NX),A1(NX,NX),B1(NX,NX1),
     &          X(NX/2),Y(NX/2),KODE(NX1),FUNC(NFM,NPM,2),IFUNC(NX1),
     &          FSCALE(NFM),NPOIF(NFM),U(NX,NSTM),T(NX1,NSTM)
      COMMON/MATG/G
      COMMON/MATH/H
      COMMON/MATA/A1
      COMMON/MATB/B1
      COMMON/MATU/U
      COMMON/MATT/T
C
C  NX IS THE MAXIMUM DIMENSION OF THE SYSTEM OF EQUATIONS
C  NX  = 2*MAXIMUM NUMBER OF NODES = 4*MAXIMUM NUMBER OF ELEMENTS
C  NX1 = 3*MAXIMUM NUMBER OF NODES = 6*MAXIMUM NUMBER OF ELEMENTS
C
C  ASSIGN NUMBERS FOR INPUT, OUTPUT AND AUXILIARY FILES
C
      INP=5
      IPR=6
      IAU=7
C
C  READ NAMES AND OPEN INPUT, OUTPUT AND AUXILIARY FILES
C
      WRITE(*,' (A,$) ') ' NAME OF THE INPUT  FILE (MAX. 12 CHAR.)    :'
      READ(*,' (A) ') FILEIN
      OPEN(INP,FILE=FILEIN,STATUS='OLD')
      WRITE(*,' (A,$) ') ' NAME OF THE OUTPUT FILE (MAX. 12 CHAR.)    :'
      READ(*,' (A) ') FILEOUT
      OPEN(IPR,FILE=FILEOUT,STATUS='NEW')
      WRITE(*,' (A,$) ') ' NAME OF THE AUXILIARY FILE (MAX. 12 CHAR.) :'
      READ(*,' (A) ') FILEAUX
      OPEN(IAU,FILE=FILEAUX,STATUS='NEW',ACCESS='SEQUENTIAL',
     &     FORM='UNFORMATTED')
C
C  READ DATA
C
      CALL INPUT12(N,INTIMP,NSTEP,AT,GE,XNU,RO,X,Y,NPOIF,FSCALE,FUNC,
     &             KODE,BC,IFUNC,CP,CS,INP,IPR,NFM,NPM)
C
      DO 20 ISTEP=1,NSTEP
      PRINT *,ISTEP
C
C  FORM MATRICES G AND H OF STEP 'ISTEP'
C
      CALL GHMAT12(X,Y,G,H,KODE,N,NX,A1,B1,ISTEP,AT,GE,XNU,
     &             RO,CP,CS,IAU)
C
C  FORM THE RIGHT HAND SIDE VECTOR ADDING THE BOUNDARY CONDITION
C  VECTOR AND THE PREVIOUS STEP EFFECT VECTOR
C
      CALL PREST12(G,H,B1,U,T,FI,BC,IFUNC,KODE,FSCALE,FUNC,NPOIF,
     &             N,ISTEP,AT,IAU,NX,NX1,NFM,NPM)
C
C  SOLVE SYSTEM OF EQUATIONS
C
      KKK=0
      IF(ISTEP.EQ.1) KKK=1
      CALL RSOLVER(A1,FI,2*N,NX,KKK)
C
C  PRINT RESULTS AT BOUNDARY NODE
C
      CALL OUTPUT12(X,Y,FI,U,T,KODE,N,NX,NX1,ISTEP,INTIMP,AT*ISTEP,IPR  
     &             ,GE)
   20 CONTINUE
      CLOSE(INP)
      CLOSE(IPR)
      CLOSE(IAU)
      STOP
      END
C-----------------------------------------------------------------------
      SUBROUTINE INPUT12(N,INTIMP,NSTEP,AT,GE,XNU,RO,X,Y,NPOIF,FSCALE,
     &                   FUNC,KODE,BC,IFUNC,CP,CS,INP,IPR,NFM,NPM)
C
      CHARACTER*80 TITLE
      DIMENSION X(1),Y(1),NPOIF(1),FSCALE(1),FUNC(NFM,NPM,2),KODE(1),
     &          BC(1),IFUNC(1)
C
C  NE=  NUMBER OF BOUNDARY ELEMENTS
C  CP=  P-WAVE VELOCITY
C  CS=  S-WAVE VELOCITY
C  RO=  DENSITY
C  GE=  SHEAR MODULUS
C  XNU= POISSON MODULUS
C  AT=  SIZE OF TIME INTERVAL
C  NSTEP= NUMBER OF TIME INTERVALS
C
C  READ JOB TITLE
C
      WRITE(IPR,'('' '',79(''*''))')
      READ(INP,'(A)') TITLE
      WRITE(IPR,'(A)') TITLE
C
C  READ GENERAL PARAMETERS
C
      READ(INP,*) NE,NFUNC,INTIMP,NSTEP,AT,GE,XNU,RO
      IF(INTIMP.EQ.0) INTIMP=NSTEP+1
      CS=SQRT(GE/RO)
      CP=CS*SQRT((2.-2.*XNU)/(1.-2.*XNU))
      WRITE(IPR,100) NE,NFUNC,INTIMP,NSTEP,AT,CP,CS,GE,XNU,RO
100   FORMAT(//2X'DATA'//2X,
     &       'NUMBER OF BOUNDARY ELEMENTS = ',I3/2X,
     &       'NUMBER OF TIME FUNCTIONS    = ',I3/2X,
     &       'INTERVAL OF PRINTING        = ',I3/2X,
     &       'NUMBER OF TIME STEPS        = ',I3/2X,
     &       'TIME INTERVAL               = ',E14.7/2X,
     &       'P-WAVE VELOCITY             = ',E14.7/2X,
     &       'S-WAVE VELOCITY             = ',E14.7/2X,
     &       'SHEAR MODULUS               = ',E14.7/2X,
     &       'POISSON RATIO               = ',E14.7/2X,
     &       'DENSITY                     = ',E14.7)
C
C  READ BOUNDARY NODES COORDINATES
C
      N=2*NE
      WRITE(IPR,200)
  200 FORMAT(//2X,'BOUNDARY NODE COORDINATES'///4X,
     &       'NODE',10X,'X',18X,'Y'/)
      READ(INP,*) (X(I),Y(I),I=1,N)
      DO 10 I=1,N
   10 WRITE(IPR,300) I,X(I),Y(I)
  300 FORMAT(5X,I3,2(5X,E14.7))
C
C  READ TIME FUNCTIONS
C
      WRITE(IPR,400)
  400 FORMAT(//2X,'TIME FUNCTIONS')
      DO 20 I=1,NFUNC
      READ(INP,*) NPOIF(I),FSCALE(I)
   20 READ(INP,*) (FUNC(I,J,1),FUNC(I,J,2),J=1,NPOIF(I))
      DO 30 I=1,NFUNC
      WRITE(IPR,500) I,NPOIF(I),FSCALE(I)
      DO 30 J=1,NPOIF(I)
   30 WRITE(IPR,600) J,FUNC(I,J,1),FUNC(I,J,2)
  500 FORMAT(/2X,'FUNCTION NUMBER  = ',I3/2X,
     &       'NUMBER OF POINTS = ',I3/2X,
     &       'FUNCTION SCALE   = ',E14.7//4X,
     &       'POINT',8X,'TIME',11X,'VALUE')
  600 FORMAT(5X,I3,4X,E14.7,2X,E14.7)
C
C  READ BOUNDARY CONDITIONS IN BC(I) AND IFUNC(I) VECTORS;
C  IF KODE(I)=0 THE BC(I) VALUE IS A KNOWN DISPLACEMENT,
C  IF KODE(I)=1 THE BC(I) VALUE IS A KNOWN TRACTION
C  THE VALUE OF THE PRESCRIBED BOUNDARY CONDITIONS IN ANY STEP IS BC(I)
C  TIMES THE VALUE OF THE IFUNC(I) FUNCTION MULTIPLIED BY FSCALE(I)
C  SIX BOUNDARY CONDITIONS ARE READ PER ELEMENT.
C  NODES BETWEN TWO ELEMENTS MAY HAVE TWO DIFFERENT VALUES OF THE
C  TRACTION BUT ONLY ONE VALUE OF THE DISPLACEMENT.
C
      WRITE(IPR,700)
      DO 40 I=1,NE
      READ(INP,*) (KODE(6*I-6+J),BC(6*I-6+J),IFUNC(6*I-6+J),J=1,6)
   40 WRITE(IPR,800) I,(BC(6*I-6+J),KODE(6*I-6+J),IFUNC(6*I-6+J),J=1,6)
  700 FORMAT(//2X,'BOUNDARY CONDITIONS'//6X,
     &       '------FIRST NODE------',2X,'-----SECOND NODE------',2X,
     &       '------THIRD NODE------'/1X,'ELE',
     &       3(2X,'X DIR. C F  Y DIR. C F'))
  800 FORMAT(1X,I3,3(F8.2,1X,I1,I2,F8.2,1X,I1,I2))
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE GHMAT12(X,Y,G,H,KODE,N,NX,A1,B1,ISTEP,AT,GE,
     &                   XNU,RO,CP,CS,IAU)
C
C  THIS SUBROUTINE COMPUTES THE G AND H MATRICES AND
C  FORM THE MATRIX A1 OF THE SYSTEM OF EQUATIONS IN THE FIRST STEP
C  H IS A SQUARE MATRIX (4*NE,4*NE); G IS RECTANGULAR (4*NE,6*NE)
C
      DIMENSION G(NX,1),H(NX,1),A1(NX,1),B1(NX,1),X(1),Y(1),KODE(1),
     &          HT(2,6),GT(2,6)

      NN=2*N
      NE=N/2
      NG=6*NE
      DO 50 I=1,NN
      DO 30 J=1,NN
   30 H(I,J)=0.0
      DO 40 J=1,NG
   40 G(I,J)=0.0
   50 CONTINUE
      CPT=CP*AT*ISTEP
C
C  COMPUTE THE COEFFICIENTS OF G AND H MATRICES
C
      DO 120 I=1,N
      DO 80 J=1,NE
      J1=2*J-1
      J2=J1+1
      J3=J2+1
      IF(J3.GT.N) J3=1
      IF((I-J1)*(I-J2)*(I-J3).EQ.0.AND.ISTEP.EQ.1) GO TO 60
C
C  CHECK WHETHER THE WAVES HAVE ARRIVED FROM THE I-NODE TO THE J-ELEMENT
C
      DIST=DISTP(X(I),Y(I),X(J1),Y(J1),X(J2),Y(J2),X(J3),Y(J3))
      IF(DIST.GT.CPT) GO TO 80
      CALL EXTIN12(X(I),Y(I),X(J1),Y(J1),X(J2),Y(J2),X(J3),Y(J3),
     &             ISTEP,AT,CP,CS,XNU,GE,RO,GT,HT)
      GO TO 70
   60 NODO=I-J1+1
      IF(I.EQ.1.AND.J.EQ.NE) NODO=3
      CALL LOCIN12(X(I),Y(I),X(J1),Y(J1),X(J2),Y(J2),X(J3),Y(J3),NODO,
     &             AT,CP,CS,XNU,GE,RO,GT,HT)
   70 II=2*I-1
      DO 75 K=1,3
      JH=4*J+2*K-5
      IF(J.EQ.NE.AND.K.EQ.3) JH=1
      JJ=6*J+2*K-7
      KK=2*K-1
      H(II  ,JH)  =H(II  ,JH)  +HT(1,KK)
      H(II+1,JH)  =H(II+1,JH)  +HT(2,KK)
      H(II  ,JH+1)=H(II  ,JH+1)+HT(1,KK+1)
      H(II+1,JH+1)=H(II+1,JH+1)+HT(2,KK+1)
      G(II  ,JJ)  =GT(1,KK)
      G(II+1,JJ)  =GT(2,KK)
      G(II  ,JJ+1)=GT(1,KK+1)
   75 G(II+1,JJ+1)=GT(2,KK+1)
   80 CONTINUE
      IF(ISTEP.NE.1) GO TO 120
      IF(2*(I/2)-I) 100,90,100
   90 C11=0.5
      C22=0.5
      C12=0.0
      GO TO 110
  100 I1=I-2
      IF(I.EQ.1) I1=N-1
      I2=I-1
      IF(I.EQ.1) I2=N
      I5=I+2
      IF(I5.GT.N) I5=1
      CALL FTERM12(C11,C12,C22,X(I1),Y(I1),X(I2),Y(I2),X(I),Y(I),
     &                X(I+1),Y(I+1),X(I5),Y(I5),CP,CS)
  110 H(2*I-1,2*I-1)=H(2*I-1,2*I-1)+C11
      H(2*I-1,2*I)  =H(2*I-1,2*I)  +C12
      H(2*I  ,2*I-1)=H(2*I  ,2*I-1)+C12
      H(2*I  ,2*I  )=H(2*I  ,2*I  )+C22
  120 CONTINUE
C
C  WRITE THE MATRICES IN AN AUXILIARY FILE
C
      WRITE(IAU) ((H(I,J), I=1,NN), J=1,NN),((G(I,J), I=1,NN), J=1,NG)
C
C  REORDER THE COLUMNS OF THE SYSTEM OF EQUATIONS IN ACCORDANCE WITH THE
C  BOUNDARY CONDITIONS AND FORM SYSTEM MATRIX WHICH IS STORED IN A1 IN
C  THE FIRST STEP
C
      IF(ISTEP.GT.1) RETURN
      DO 220 J=1,NN
      JB=J-2+2*((J+1)/4)
      IF(JB.LT.1) JB=JB+NG
      JA=J+2*((J-1)/4)
      IF(JA.GT.NG) JA=JA-2
      KODEB=KODE(JB)
      KODEA=KODE(JA)
      IF(KODEB.EQ.0.OR.KODEA.EQ.0) GO TO 140
      DO 130 I=1,NN
      A1(I,J)=H(I,J)
      B1(I,JB)=G(I,JB)
  130 B1(I,JA)=G(I,JA)
      GO TO 220
  140 IF(KODEB.EQ.1.OR.KODEA.EQ.1.OR.JB.NE.JA) GO TO 160
      DO 150 I=1,NN
      A1(I,J)=-GE*G(I,JB)
  150 B1(I,JB)=-H(I,J)
      GO TO 220
  160 IF(KODEB.EQ.1.OR.KODEA.EQ.1.OR.JB.EQ.JA) GO TO 180
      DO 170 I=1,NN
      A1(I,J)=-GE*(G(I,JB)+G(I,JA))
      B1(I,JB)=-H(I,J)
  170 B1(I,JA)=0.0
      GO TO 220
  180 IF(KODEB.EQ.1.OR.KODEA.EQ.0) GO TO 200
      DO 190 I=1,NN
      A1(I,J)=-GE*G(I,JB)
      B1(I,JB)=-H(I,J)
  190 B1(I,JA)=G(I,JA)
      GO TO 220
  200 IF(KODEB.EQ.0.OR.KODEA.EQ.1) GO TO 220
      DO 210 I=1,NN
      A1(I,J)=-GE*G(I,JA)
      B1(I,JB)=G(I,JB)
  210 B1(I,JA)=-H(I,J)
  220 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE EXTIN12(XP,YP,X1,Y1,X2,Y2,X3,Y3,ISTEP,AT,CP,CS,XNU,GE,
     &                   RO,GT,HT)
C
C  THIS SUBROUTINE COMPUTES THE G AND H MATRICES
C  COEFFICIENTS THAT RELATE A COLOCATION POINT WITH AN ELEMENT
C  TO WHICH THE POINT DOES NOT BELONG USING GAUSS QUADRATURE
C
C  RA            = RADIUS
C  RD1,RD2,RDN   = RADIUS DERIVATIVES
C  ETA1,ETA2     = COMPONENTS OF THE UNIT NORMAL TO THE ELEMENT
C  GI(I)         = GAUSS QUADRATURE POINTS
C  OME(I)        = GAUSS QUADRATURE WEIGHTS
C  XCO,YCO       = INTEGRATION POINTS ALONG THE ELEMENT
C
      DIMENSION GI(10),OME(10),HT(2,6),GT(2,6)
      DATA GI/0.9739065285,-0.9739065285,0.8650633666,-0.8650633666,
     &        0.6794095682,-0.6794095682,0.4333953941,-0.4333953941,
     &        0.1488743389,-0.1488743389/
      DATA OME/0.0666713443,0.0666713443,0.1494513491,0.1494513491,
     &         0.2190863625,0.2190863625,0.2692667193,0.2692667193,
     &         0.2955242247,0.2955242247/
      DO 10 I=1,2
      DO 10 J=1,6
      HT(I,J)=0.0
   10 GT(I,J)=0.0
      A=X3-2.*X2+X1
      B=(X3-X1)/2
      C=Y3-2.*Y2+Y1
      D=(Y3-Y1)/2
      CPT=CP*AT*ISTEP
      DO 20 I=1,10
C
C  COMPUTE THE VALUE OF THE SHAPE FUNCTIONS
C
      F1=GI(I)*(GI(I)-1.)*0.5
      F2=1.-GI(I)**2
      F3=GI(I)*(GI(I)+1.)*0.5
      XCO=(X1-XP)*F1+(X2-XP)*F2+(X3-XP)*F3
      YCO=(Y1-YP)*F1+(Y2-YP)*F2+(Y3-YP)*F3
      RA=SQRT(XCO**2+YCO**2)
      IF(RA.GT.CPT) GO TO 20
      RD1=XCO/RA
      RD2=YCO/RA
      CALL FUNDSOLE(E1,E2,Z1,Z2,Z3,RA,ISTEP,AT,CP,CS,XNU,GE,RO)
      XJA=SQRT((GI(I)*A+B)**2+(GI(I)*C+D)**2)*OME(I)
      GH=XJA*(E1-E2+2*RD1*RD1*E2)
      GT(1,1)=GT(1,1)+F1*GH
      GT(1,3)=GT(1,3)+F2*GH
      GT(1,5)=GT(1,5)+F3*GH
      GH=XJA*(2*RD1*RD2*E2)
      GT(1,2)=GT(1,2)+F1*GH
      GT(1,4)=GT(1,4)+F2*GH
      GT(1,6)=GT(1,6)+F3*GH
      GH=XJA*(E1-E2+2*RD2*RD2*E2)
      GT(2,2)=GT(2,2)+F1*GH
      GT(2,4)=GT(2,4)+F2*GH
      GT(2,6)=GT(2,6)+F3*GH
      ETA1= (C*GI(I)+D)
      ETA2=-(A*GI(I)+B)
      RDN=RD1*ETA1+RD2*ETA2
      GH=OME(I)*(RDN*(Z1+2.*RD1*RD1*Z2)+ETA1*RD1*(Z1+Z3))/RA
      HT(1,1)=HT(1,1)+F1*GH
      HT(1,3)=HT(1,3)+F2*GH
      HT(1,5)=HT(1,5)+F3*GH
      GH=OME(I)*(RDN*2.*RD1*RD2*Z2+ETA1*RD2*Z1+ETA2*RD1*Z3)/RA
      HT(1,2)=HT(1,2)+F1*GH
      HT(1,4)=HT(1,4)+F2*GH
      HT(1,6)=HT(1,6)+F3*GH
      GH=OME(I)*(RDN*2.*RD1*RD2*Z2+ETA1*RD2*Z3+ETA2*RD1*Z1)/RA
      HT(2,1)=HT(2,1)+F1*GH
      HT(2,3)=HT(2,3)+F2*GH
      HT(2,5)=HT(2,5)+F3*GH
      GH=OME(I)*(RDN*(Z1+2.*RD2*RD2*Z2)+ETA2*RD2*(Z1+Z3))/RA
      HT(2,2)=HT(2,2)+F1*GH
      HT(2,4)=HT(2,4)+F2*GH
      HT(2,6)=HT(2,6)+F3*GH
   20 CONTINUE
      GT(2,1)=GT(1,2)
      GT(2,3)=GT(1,4)
      GT(2,5)=GT(1,6)
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE LOCIN12(XP,YP,X1,Y1,X2,Y2,X3,Y3,NODO,AT,CP,CS,XNU,GE,
     &                   RO,GT,HT)
C
C  THIS SUBROUTINE COMPUTES THE G AND H MATRICES WHEN THE COLLOCATION
C  POINT IS ONE OF THE NODES OF THE INTEGRATION ELEMENT.
C  THE COEFFICIENTS ARE COMPUTED BY NUMERICAL INTEGRATION:
C  THE NON-SINGULAR PART IS COMPUTED USING STANDARD GAUSS QUADRATURE,
C  THE LOGARITHMIC PART IS COMPUTED USING A SPECIAL QUADRATURE FORMULA.
C
      PARAMETER(PI=3.1415926535)
      DIMENSION GT(2,6),HT(2,6),GI(10),OME(10),GIL(10),OMEL(10)
C
C  DATA FOR THE GAUSS QUADRATURE
C
      DATA GI/0.9739065285,-0.9739065285,0.8650633666,-0.8650633666,
     &        0.6794095682,-0.6794095682,0.4333953941,-0.4333953941,
     &        0.1488743389,-0.1488743389/
      DATA OME/0.0666713443,0.0666713443,0.1494513491,0.1494513491,
     &         0.2190863625,0.2190863625,0.2692667193,0.2692667193,
     &         0.2955242247,0.2955242247/
C
C  DATA FOR THE SPECIAL QUADRATURE
C
      DATA GIL/0.0090426309,0.0539712662,0.1353118246,0.2470524162,
     &         0.3802125396,0.5237923179,0.6657752055,0.7941904160,
     &         0.8981610912,0.9688479887/
      DATA OMEL/0.1209551319,0.1863635425,0.1956608732,0.1735771421,
     &          0.1356956729,0.0936467585,0.0557877273,0.0271598109,
     &          0.0095151826,0.0016381576/
      A=X3-2.*X2+X1
      B=(X3-X1)/2
      C=Y3-2.*Y2+Y1
      D=(Y3-Y1)/2
      RES1=0.0
      RES2=0.0
      RES3=0.0
      GOTO(10,20,30),NODO
   10 A1=0.5
      A0=0.5
      XJAL=2.0
      RES1=1.0
      GO TO 40
   20 A1=1.0
      A0=0.0
      XJAL=1.0
      RES2=1.0
      GO TO 40
   30 A1=-0.5
      A0=0.5
      XJAL=2.0
      RES3=1.0
   40 CTU=(3.0-4.0*XNU)/8.0/PI/GE/(1.0-XNU)
      CTT=(1.0-2.0*XNU)/4.0/PI/(1.0-XNU)
      DO 50 I=1,2
      DO 50 J=1,6
      HT(I,J)=0.0
   50 GT(I,J)=0.0
C
      DO 70 I=1,10
C
C     INTEGRATE LOGARITHMIC COMPONENT
C
      GIA=(GIL(I)-A0)/A1
      XJA=CTU*XJAL*SQRT((GIA*A+B)**2+(GIA*C+D)**2)*OMEL(I)
      S1=0.5*GIA*(GIA-1.)*XJA
      S2=     (1.-GIA**2)*XJA
      S3=0.5*GIA*(GIA+1.)*XJA
      IF(NODO.NE.2) GO TO 60
      GIA=-GIL(I)
      XJA=CTU*SQRT((GIA*A+B)**2+(GIA*C+D)**2)*OMEL(I)
      S1=S1+0.5*GIA*(GIA-1.)*XJA
      S2=S2+     (1.-GIA**2)*XJA
      S3=S3+0.5*GIA*(GIA+1.)*XJA
C
C     INTEGRATE NON-SINGULAR COMPONENT
C
   60 F1=0.5*GI(I)*(GI(I)-1.0)
      F2=1.0-GI(I)**2
      F3=0.5*GI(I)*(GI(I)+1.0)
      XCO=(X1-XP)*F1+(X2-XP)*F2+(X3-XP)*F3
      YCO=(Y1-YP)*F1+(Y2-YP)*F2+(Y3-YP)*F3
      RA=SQRT(XCO*XCO+YCO*YCO)
      RD1=XCO/RA
      RD2=YCO/RA
      XJA=SQRT((GI(I)*A+B)**2+(GI(I)*C+D)**2)*OME(I)
      CALL FUNDSOLE(E1,E2,Z1,Z2,Z3,RA,1,AT,CP,CS,XNU,GE,RO)
      ETA=ABS(A1*GI(I)+A0)
      E1=E1+CTU*LOG(ETA)
      GH=XJA*(E1-E2+2*RD1*RD1*E2)
      GT(1,1)=GT(1,1)+F1*GH+S1
      GT(1,3)=GT(1,3)+F2*GH+S2
      GT(1,5)=GT(1,5)+F3*GH+S3
      GH=XJA*(2*RD1*RD2*E2)
      GT(1,2)=GT(1,2)+F1*GH
      GT(1,4)=GT(1,4)+F2*GH
      GT(1,6)=GT(1,6)+F3*GH
      GH=XJA*(E1-E2+2*RD2*RD2*E2)
      GT(2,2)=GT(2,2)+F1*GH+S1
      GT(2,4)=GT(2,4)+F2*GH+S2
      GT(2,6)=GT(2,6)+F3*GH+S3
      ETA1= (C*GI(I)+D)
      ETA2=-(A*GI(I)+B)
      RDN=RD1*ETA1+RD2*ETA2
      GH=OME(I)*(RDN*(Z1+2.*RD1*RD1*Z2)+ETA1*RD1*(Z1+Z3))/RA
      HT(1,1)=HT(1,1)+F1*GH
      HT(1,3)=HT(1,3)+F2*GH
      HT(1,5)=HT(1,5)+F3*GH
      GH=OME(I)*(RDN*(Z1+2.*RD2*RD2*Z2)+ETA2*RD2*(Z1+Z3))/RA
      HT(2,2)=HT(2,2)+F1*GH
      HT(2,4)=HT(2,4)+F2*GH
      HT(2,6)=HT(2,6)+F3*GH
      Z1=Z1+CTT
      Z3=Z3-CTT
      GH=OME(I)*(RDN*2.*RD1*RD2*Z2+ETA1*RD2*Z1+ETA2*RD1*Z3)/RA
      GHA=OME(I)*CTT*(ETA1*RD2-ETA2*RD1)/RA
      HT(1,2)=HT(1,2)+F1*GH+(RES1-F1)*GHA
      HT(1,4)=HT(1,4)+F2*GH+(RES2-F2)*GHA
      HT(1,6)=HT(1,6)+F3*GH+(RES3-F3)*GHA
      GH=OME(I)*(RDN*2.*RD1*RD2*Z2+ETA1*RD2*Z3+ETA2*RD1*Z1)/RA
      HT(2,1)=HT(2,1)+F1*GH-(RES1-F1)*GHA
      HT(2,3)=HT(2,3)+F2*GH-(RES2-F2)*GHA
      HT(2,5)=HT(2,5)+F3*GH-(RES3-F3)*GHA
   70 CONTINUE
      GT(2,1)=GT(1,2)
      GT(2,3)=GT(1,4)
      GT(2,5)=GT(1,6)
C
C     ADD THE SINGULAR COMPONENT OF TRACTIONS
C
      R1=(X1-XP)**2+(Y1-YP)**2
      R3=(X3-XP)**2+(Y3-YP)**2
      GOTO(80,90,100) NODO
   80 HT(1,2)=HT(1,2)-CTT*0.5*LOG(R3)
      HT(2,1)=HT(2,1)+CTT*0.5*LOG(R3)
      GO TO 110
   90 HT(1,4)=HT(1,4)-CTT*0.5*LOG(R3/R1)
      HT(2,3)=HT(2,3)+CTT*0.5*LOG(R3/R1)
      GO TO 110
  100 HT(1,6)=HT(1,6)+CTT*0.5*LOG(R1)
      HT(2,5)=HT(2,5)-CTT*0.5*LOG(R1)
  110 RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE FTERM12(C11,C12,C22,X1,Y1,X2,Y2,X3,Y3,X4,Y4,X5,Y5,
     &                      CP,CS)
C
C  THIS SUBROUTINE COMPUTES THE FREE TERM MATRIX (Cij)
C
      PARAMETER (PI=3.1415926535)
      ZETA1=ATAN2(-0.5*X1+2.0*X2-1.5*X3, 0.5*Y1-2.0*Y2+1.5*Y3)
      ZETA2=ATAN2( 1.5*X3-2.0*X4+0.5*X5,-1.5*Y3+2.0*Y4-0.5*Y5)
      ZET=ZETA2-ZETA1
      IF(ABS(ABS(ZET)-PI).LT.1E-4)
     &   STOP ' ERROR IN FREETERM12: COINCIDENT ELEMENTS'
      IF(INT(ZET/PI)) 10,20,30
   10 ZET=0.5*(-1-ZET/PI)
      GO TO 40
   20 ZET=0.5*(1-ZET/PI)
      GO TO 40
   30 ZET=0.5*(3-ZET/PI)
   40 CTE=(1.0-(CS/CP)**2)/4.0/PI
      C11=ZET-CTE*(SIN(2*ZETA1)-SIN(2*ZETA2))
      C12=CTE*(COS(2*ZETA1)-COS(2*ZETA2))
      C22=ZET+CTE*(SIN(2*ZETA1)-SIN(2*ZETA2))
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE FUNDSOLE(E1,E2,Z1,Z2,Z3,RA,ISTEP,AT,CP,CS,XNU,GE,RO)
C
C  THIS SUBROUTINE COMPUTES THE FUNDAMENTAL SOLUTION COMPONENTS
C
      PARAMETER(PI=3.1415926535)
      ACOSH(X)=ALOG(X+SQRT(X**2-1.0))
      RAIS(X)=SQRT(X*X-1.0)/X
C
      E1=0.0
      E2=0.0
      Z1=0.0
      Z2=0.0
      Z3=0.0
      P0=CP*ISTEP*AT/RA
      IF(P0.LE.1.0) RETURN
      P1=AMAX1(1.0,CP*(ISTEP-1)*AT/RA)
      P2=AMAX1(1.0,CP*(ISTEP-2)*AT/RA)
      S0=AMAX1(1.0,CS*ISTEP*AT/RA)
      S1=AMAX1(1.0,CS*(ISTEP-1)*AT/RA)
      S2=AMAX1(1.0,CS*(ISTEP-2)*AT/RA)
      CPS=2.0*(1.0-XNU)/(1.0-2.0*XNU)
      PS0=(P0/S0)**2-1.0
      PS1=(P1/S1)**2-1.0
      PS2=(P2/S2)**2-1.0
      RAIS0=RAIS(P0)+RAIS(S0)
      RAIS1=RAIS(P1)+RAIS(S1)
      RAIS2=RAIS(P2)+RAIS(S2)
      CTE=1./4./PI/RO/CP/CP
      E1=CTE*((ACOSH(P0)-ACOSH(P1))+CPS*(ACOSH(S0)-ACOSH(S1)))
      E2=CTE*PS0/RAIS0
      IF(P1.GT.1.0) E2=E2-CTE*PS1/RAIS1
      V1=     ISTEP/3.*(RAIS(P0)*RAIS0+RAIS(S0)**2)*PS0/RAIS0
      IF(P1.GT.1.0) V1=V1-
     &  2*(ISTEP-1)/3.*(RAIS(P1)*RAIS1+RAIS(S1)**2)*PS1/RAIS1
      IF(P2.GT.1.0) V1=V1+
     &    (ISTEP-2)/3.*(RAIS(P2)*RAIS2+RAIS(S2)**2)*PS2/RAIS2
      V2=ISTEP*RAIS(P0)/2.-(ISTEP-1)*RAIS(P1)+(ISTEP-2)*RAIS(P2)/2.
      V3=ISTEP*RAIS(S0)/2.-(ISTEP-1)*RAIS(S1)+(ISTEP-2)*RAIS(S2)/2.
      CTZ=4.0*GE*CTE
      Z1=CTZ*(V1-CPS*V3)
      Z2=CTZ*(-2.0*V1-(V2-CPS*V3))
      Z3=CTZ*(V1-2.0*XNU/(1.0-2.0*XNU)*V2)
      RETURN
      END
C-----------------------------------------------------------------------
      FUNCTION DISTP(XP,YP,X1,Y1,X2,Y2,X3,Y3)
      D1=(XP-X1)**2+(YP-Y1)**2
      D2=(XP-X2)**2+(YP-Y2)**2
      D3=(XP-X3)**2+(YP-Y3)**2
      DISTP=0.98*SQRT(MIN(D1,D2,D3))
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE PREST12(G,H,B1,U,T,FI,BC,IFUNC,KODE,FSCALE,FUNC,NPOIF,
     &                   N,ISTEP,AT,IAU,NX,NX1,NFM,NPM)
C
C  THIS SUBROUTINE ADDS THE CONTRIBUTION OF PREVIOUS STEPS AND THE
C  CONTRIBUTION OF BOUNDARY CONDITION TO FORM THE RIGHT HAND SIDE VECTOR
C
      DIMENSION G(NX,1),H(NX,1),B1(NX,1),U(NX,1),T(NX1,1),IFUNC(1),
     &          FI(1),BC(1),KODE(1),FSCALE(1),FUNC(NFM,NPM,2),NPOIF(1)
C
      NN=2*N
      NE=N/2
      NG=6*NE
      DO 10 J=1,NN
   10 FI(J)=0.0
      TIME=AT*ISTEP
      DO 100 J=1,NN
      JB=J-2+2*((J+1)/4)
      IF(JB.LT.1) JB=JB+NG
      JA=J+2*((J-1)/4)
      IF(JA.GT.NG) JA=JA-2
      KODEB=KODE(JB)
      KODEA=KODE(JA)
      NF=IFUNC(JB)
      BCVALB=FUNCVAL(NF,TIME,BC(JB)*FSCALE(NF),NPOIF(NF),FUNC,NFM,NPM)
      BCVALA=BCVALB
      IF(JB.EQ.JA) GO TO 20
      NF=IFUNC(JA)
      BCVALA=FUNCVAL(NF,TIME,BC(JA)*FSCALE(NF),NPOIF(NF),FUNC,NFM,NPM)
   20 IF(KODEB.EQ.0.OR.KODEA.EQ.0.OR.JB.NE.JA) GO TO 30
      T(JB,ISTEP)=BCVALB
      BCVALA=0.0
      GO TO 80
   30 IF(KODEB.EQ.0.OR.KODEA.EQ.0.OR.JB.EQ.JA) GO TO 40
      T(JB,ISTEP)=BCVALB
      T(JA,ISTEP)=BCVALA
      GO TO 80
   40 IF(KODEB.EQ.1.OR.KODEA.EQ.1) GO TO 50
      IF(BCVALB.NE.BCVALA) STOP ' ERROR 1 IN BOUNDARY CONDITIONS'
      U(J,ISTEP)=BCVALB
      BCVALA=0.0
      GO TO 80
   50 IF(KODEB.EQ.1.OR.KODEA.EQ.0) GO TO 60
      U(J,ISTEP)=BCVALB
      T(JA,ISTEP)=BCVALA
      GO TO 80
   60 IF(KODEB.EQ.0.OR.KODEA.EQ.1) GO TO 70
      T(JB,ISTEP)=BCVALB
      U(J,ISTEP)=BCVALA
      GO TO 80
   70 STOP ' ERROR 2 IN BOUNDARY CONDITIONS'
   80 IF(BCVALB.EQ.0.0.AND.BCVALA.EQ.0.0) GO TO 100
      DO 90 I=1,NN
   90 FI(I)=FI(I)+B1(I,JB)*BCVALB+B1(I,JA)*BCVALA
  100 CONTINUE
      IF(ISTEP.EQ.1) RETURN
      REWIND IAU
      READ(IAU)
      DO 140 IMAT=2,ISTEP
      READ(IAU) ((H(I,J), I=1,NN), J=1,NN),((G(I,J), I=1,NN), J=1,NG)
      IUT=ISTEP-IMAT+1
      DO 120 J=1,NN
      DISP=U(J,IUT)
      IF(DISP.EQ.0.0) GO TO 120
      DO 110 I=1,NN
  110 FI(I)=FI(I)-H(I,J)*DISP
  120 CONTINUE
      DO 140 J=1,NG
      TRAC=T(J,IUT)
      IF(TRAC.EQ.0.0) GO TO 140
      DO 130 I=1,NN
  130 FI(I)=FI(I)+G(I,J)*TRAC
  140 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      FUNCTION FUNCVAL(NF,TT,SCALE,NPOIN,FUNC,NFM,NPM)
      DIMENSION FUNC(NFM,NPM,2)
      FUNCVAL=FUNC(NF,1,2)*SCALE
      IF(SCALE.EQ.0.0) RETURN
      DO 10 I=1,NPOIN-1
      IF(TT.LT.FUNC(NF,I,1).OR.TT.GE.FUNC(NF,I+1,1)) GO TO 10
      FUNCVAL=SCALE*(FUNC(NF,I,2)+(FUNC(NF,I+1,2)-FUNC(NF,I,2))/
     &        (FUNC(NF,I+1,1)-FUNC(NF,I,1))*(TT-FUNC(NF,I,1)))
      RETURN
   10 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE OUTPUT12(X,Y,FI,U,T,KODE,N,NX,NX1,ISTEP,INTIMP,TIME,IPR
     &                   ,GE)
C
C  THIS SUBROUTINE PRINTS THE VALUES OF THE DISPLACEMENTS AND
C  TRACTIONS AT BOUNDARY NODES. IT ALSO PUTS THE CALCULATED VALUES AND
C  BOUNDARY CONDITION IN THEIR CORRESPONDING VECTORS
C
      DIMENSION FI(1),X(1),Y(1),U(NX,1),T(NX1,1),KODE(1)
C
      NN=2*N
      NE=N/2
      NG=6*NE
      DO 50 J=1,NN
      JB=J-2+2*((J+1)/4)
      IF(JB.LT.1) JB=JB+NG
      JA=J+2*((J-1)/4)
      IF(JA.GT.NG) JA=JA-2
      KODEB=KODE(JB)
      KODEA=KODE(JA)
      IF(KODEB.EQ.0.OR.KODEA.EQ.0) GO TO 10
      U(J,ISTEP)=FI(J)
      GO TO 50
   10 IF(KODEB.EQ.1.OR.KODEA.EQ.1) GO TO 20
      T(JB,ISTEP)=GE*FI(J)
      T(JA,ISTEP)=GE*FI(J)
      GO TO 50
   20 IF(KODEB.EQ.1.OR.KODEA.EQ.0) GO TO 30
      T(JB,ISTEP)=GE*FI(J)
      GO TO 50
   30 IF(KODEB.EQ.0.OR.KODEA.EQ.1) GO TO 40
      T(JA,ISTEP)=GE*FI(J)
      GO TO 50
   40 STOP ' ERROR 3 IN BOUNDARY CONDITIONS'
   50 CONTINUE
      IF((ISTEP/INTIMP)*INTIMP.NE.ISTEP.AND.ISTEP.NE.1) RETURN
      WRITE(IPR,100) TIME
      DO 60 I=1,N
   60 WRITE(IPR,200) X(I),Y(I),U(2*I-1,ISTEP),U(2*I,ISTEP)
      WRITE(IPR,300)
      WRITE(IPR,400) X(1),Y(1),T(6*NE-1,ISTEP),T(6*NE,ISTEP),
     &               T(1,ISTEP),T(2,ISTEP)
      WRITE(IPR,400) X(2),Y(2),T(3,ISTEP),T(4,ISTEP),
     &               T(3,ISTEP),T(4,ISTEP)
      DO 70 I=2,NE
      WRITE(IPR,400) X(2*I-1),Y(2*I-1),T(6*I-7,ISTEP),T(6*I-6,ISTEP),
     &               T(6*I-5,ISTEP),T(6*I-4,ISTEP)
   70 WRITE(IPR,400) X(2*I),  Y(2*I),  T(6*I-3,ISTEP),T(6*I-2,ISTEP),
     &               T(6*I-3,ISTEP),T(6*I-2,ISTEP)
C
  100 FORMAT(' ',79('*')//' RESULTS AT TIME = ',E12.5//
     &       '  BOUNDARY NODES'//10X,'X',17X,'Y',11X,'DISPLACEMENT X',
     &       4X,'DISPLACEMENT Y'/)
  200 FORMAT(4(4X,E14.7))
  300 FORMAT(///28X,'TRACTION X',3X,'TRACTION Y',3X,'TRACTION X',3X,
     &       'TRACTION Y'/7X,'X',12X,'Y',7X,'BEFORE NODE',2X,
     &       'BEFORE NODE',2X,'AFTER NODE',3X,'AFTER NODE'/)
  400 FORMAT(6(1X,E12.5))
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE RSOLVER(A,B,N,NX,KKK)
C
      REAL A(NX,NX),B(NX),X,RDOT
C
C  A=L*U  FACTORIZATION
C
C  KKK=0 : ONLY FORWARD AND BACK SUSTITUTION
C  KKK=1 : FACTORIZATION AND FORWARD AND BACK SUSTITUTION
C
      IF(KKK.EQ.0) GO TO 30
      DO 20 K=1,N
      K1=K-1
      DO 10 I=K,N
   10 A(I,K)=A(I,K)-RDOT(K1,A(I,1),NX,A(1,K),1)
      X=A(K,K)
      IF(X.NE.0.) GOTO 15
      WRITE(6,*) ' SOLVER : STOP  SINGULARITY IN ROW ',K
      STOP ' SOLVER : STOP SINGULARITY '
   15 X=1./X
      DO 20 J=K+1,N
   20 A(K,J)=X*(A(K,J)-RDOT(K1,A(K,1),NX,A(1,J),1))
   30 CONTINUE
C
C  FORWARD AND BACK SUBSTITUTION    L*U*X=B
C
C  SOLVE  L*Y=B
C
      DO 40 I=1,N
      B(I)=-(RDOT((I-1),A(I,1),NX,B,1)+B(I))/A(I,I)
   40 CONTINUE
C
C  SOLVE  U*X=Y
C
      DO 50 I=N,1,-1
      B(I)=-(RDOT((N-I),A(I,I+1),NX,B(I+1),1)+B(I))
   50 CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      FUNCTION RDOT(N,U,IUX,V,IVX)
C
C THIS FUNCTION MAKES THE REAL DOT PRODUCT OF TWO VECTORS
C
      REAL U(1),V(1)
C
      RDOT=0.
      IF(N.LE.0) RETURN
      IU=1
      IV=1
      IF(IUX.LT.0) IU=1-(N-1)*IUX
      IF(IVX.LT.0) IV=1-(N-1)*IVX
      DO 10 I=1,N
      RDOT=RDOT+U(IU)*V(IV)
      IU=IU+IUX
   10 IV=IV+IVX
      RETURN
      END
