      PROGRAM QUADPLST
C
C  THIS IS A B.E. PROGRAM THAT USES (QUA)DRATIC ELEMENTS FOR THE
C  SOLUTION OF (D)YNAMIC (PL)ANE (S)CALAR (T)IME DOMAIN PROBLEMS
C  PROGRAM NO. 10
C
      PARAMETER(NX=50,NX1=(3*NX)/2,NSTM=30,NFM=10,NPM=15)
      CHARACTER*12 FILEIN,FILEOUT,FILEAUX
      DIMENSION G(NX,NX1),H(NX,NX),BC(NX1),FI(NX),A1(NX,NX),B1(NX,NX1),
     &          X(NX+1),Y(NX+1),KODE(NX1),FUNC(NFM,NPM,2),IFUNC(NX1),
     &          FSCALE(NFM),NPOIF(NFM),U(NX,NSTM),T(NX1,NSTM)
      COMMON/MATG/G
      COMMON/MATH/H
      COMMON/MATA/A1
      COMMON/MATB/B1
      COMMON/MATU/U
      COMMON/MATT/T
C
C  NX IS THE MAXIMUM DIMENSION OF THE SYSTEM OF EQUATIONS
C  NX  = MAXIMUM NUMBER OF NODES     = 2*MAXIMUM NUMBER OF ELEMENTS
C  NX1 = 3*MAXIMUM NUMBER OF NODES/2 = 3*MAXIMUM NUMBER OF ELEMENTS
C
C  ASSIGN NUMBERS FOR INPUT, OUTPUT AND AUXILIARY FILES
C
      INP=5
      IPR=6
      IAU=7
C
C  READ NAMES AND OPEN INPUT, OUTPUT AND AUXILIARY FILES
C
      WRITE(*,' (A,$) ') ' NAME OF THE INPUT  FILE (MAX. 12 CHAR.)    :'
      READ(*,' (A) ') FILEIN
      OPEN(INP,FILE=FILEIN,STATUS='OLD')
      WRITE(*,' (A,$) ') ' NAME OF THE OUTPUT FILE (MAX. 12 CHAR.)    :'
      READ(*,' (A) ') FILEOUT
      OPEN(IPR,FILE=FILEOUT,STATUS='NEW')
      WRITE(*,' (A,$) ') ' NAME OF THE AUXILIARY FILE (MAX. 12 CHAR.) :'
      READ(*,' (A) ') FILEAUX
      OPEN(IAU,FILE=FILEAUX,STATUS='NEW',ACCESS='SEQUENTIAL',
     &     FORM='UNFORMATTED')
C
C  READ DATA
C
      CALL INPUT10(N,INTIMP,NSTEP,AT,X,Y,NPOIF,FSCALE,FUNC,KODE,BC,
     &             IFUNC,CS,INP,IPR,NFM,NPM)
C
      DO 20 ISTEP=1,NSTEP
      PRINT *,ISTEP
C
C  FORM MATRICES G AND H OF STEP 'ISTEP'
C
      CALL GHMAT10(X,Y,G,H,KODE,N,NX,A1,B1,ISTEP,AT,
     &             CS,IAU)
C
C  FORM THE RIGHT HAND SIDE VECTOR ADDING THE BOUNDARY CONDITION
C  VECTOR AND THE PREVIOUS STEP EFFECT VECTOR
C
      CALL PREST10(G,H,B1,U,T,FI,BC,IFUNC,KODE,FSCALE,FUNC,NPOIF,
     &             N,ISTEP,AT,IAU,NX,NX1,NFM,NPM)
C
C  SOLVE SYSTEM OF EQUATIONS
C
      KKK=0
      IF(ISTEP.EQ.1) KKK=1
      CALL RSOLVER(A1,FI,N,NX,KKK)
C
C  PRINT RESULTS AT BOUNDARY NODE
C
      CALL OUTPUT10(X,Y,FI,U,T,KODE,N,NX,NX1,ISTEP,INTIMP,AT*ISTEP,IPR)
   20 CONTINUE
      CLOSE(INP)
      CLOSE(IPR)
      CLOSE(IAU)
      STOP
      END
C-----------------------------------------------------------------------
      SUBROUTINE INPUT10(N,INTIMP,NSTEP,AT,X,Y,NPOIF,FSCALE,FUNC,KODE,
     &                   BC,IFUNC,CS,INP,IPR,NFM,NPM)
C
      CHARACTER*80 TITLE
      DIMENSION X(1),Y(1),NPOIF(1),FSCALE(1),FUNC(NFM,NPM,2),KODE(1),
     &          BC(1),IFUNC(1)
C
C  N =  NUMBER OF BOUNDARY NODES
C  NE=  NUMBER OF BOUNDARY ELEMENTS
C  CS=  WAVE VELOCITY
C  AT=  SIZE OF TIME INTERVAL
C  NSTEP= NUMBER OF TIME INTERVALS
C
C  READ JOB TITLE
C
      WRITE(IPR,'('' '',79(''*''))')
      READ(INP,'(A)') TITLE
      WRITE(IPR,'(A)') TITLE
C
C  READ GENERAL PARAMETERS
C
      READ(INP,*) NE,NFUNC,INTIMP,NSTEP,AT,CS
      IF(INTIMP.EQ.0) INTIMP=NSTEP+1
      WRITE(IPR,100) NE,NFUNC,INTIMP,NSTEP,AT,CS
100   FORMAT(//' DATA'//2X,
     &      'NUMBER OF BOUNDARY ELEMENTS = ',I3/2X,
     &      'NUMBER OF TIME FUNCTIONS    = ',I3/2X,
     &      'INTERVAL OF PRINTING        = ',I3/2X,
     &      'NUMBER OF TIME STEPS        = ',I3/2X,
     &      'TIME INTERVAL               = ',E14.7/2X,
     &      'WAVE VELOCITY               = ',E14.7/2X)
C
C  READ BOUNDARY NODES COORDINATES
C
      N=2*NE
      WRITE(IPR,200)
  200 FORMAT(//2X,'BOUNDARY NODE COORDINATES'///4X,
     &       'NODE',10X,'X',18X,'Y'/)
      READ(INP,*) (X(I),Y(I),I=1,N)
      DO 10 I=1,N
   10 WRITE(IPR,300) I,X(I),Y(I)
  300 FORMAT(5X,I3,2(5X,E14.7))
C
C  READ TIME FUNCTIONS
C
      WRITE(IPR,400)
  400 FORMAT(//2X,'TIME FUNCTIONS')
      DO 20 I=1,NFUNC
      READ(INP,*) NPOIF(I),FSCALE(I)
   20 READ(INP,*) (FUNC(I,J,1),FUNC(I,J,2),J=1,NPOIF(I))
      DO 30 I=1,NFUNC
      WRITE(IPR,500) I,NPOIF(I),FSCALE(I)
      DO 30 J=1,NPOIF(I)
   30 WRITE(IPR,600) J,FUNC(I,J,1),FUNC(I,J,2)
  500 FORMAT(/2X,'FUNCTION NUMBER  = ',I3/2X,
     &       'NUMBER OF POINTS = ',I3/2X,
     &       'FUNCTION SCALE   = ',E14.7//4X,
     &       'POINT',8X,'TIME',11X,'VALUE')
  600 FORMAT(5X,I3,4X,E14.7,2X,E14.7)
C
C  READ BOUNDARY CONDITIONS IN BC(I) AND IFUNC(I) VECTORS;
C  IF KODE(I)=0 THE BC(I) VALUE IS A KNOWN POTENTIAL,
C  IF KODE(I)=1 THE BC(I) VALUE IS A KNOWN FLUX.
C  THE VALUE OF THE PRESCRIBED BOUNDARY CONDITIONS IN ANY STEP IS BC(I)
C  TIMES THE VALUE OF THE IFUNC(I) FUNCTION MULTIPLIED BY FSCALE(I)
C  THREE BOUNDARY CONDITIONS ARE READ PER ELEMENT.
C  NODES BETWEN TWO ELEMENTS MAY HAVE TWO DIFFERENT VALUES OF THE
C  FLUX BUT ONLY ONE VALUE OF THE POTENTIAL.
C
      WRITE(IPR,700)
      DO 40 I=1,NE
      READ(INP,*) (KODE(3*I-3+J),BC(3*I-3+J),IFUNC(3*I-3+J),J=1,3)
   40 WRITE(IPR,800) I,(BC(3*I-3+J),KODE(3*I-3+J),IFUNC(3*I-3+J),J=1,3)
  700 FORMAT(//2X,'BOUNDARY CONDITIONS'//11X,
     &       '-----FIRST NODE-----',4X,'-----SECOND NODE----',4X,
     &       '-----THIRD NODE-----'/11X,'PRESCRIBED',14X,
     &       'PRESCRIBED',14X,'PRESCRIBED'/
     &       1X,'ELEMENT',5X,'VALUE',4X,'CODE FUNC.',5X,'VALUE',4X,
     &       'CODE FUNC.',5X,'VALUE',4X,'CODE FUNC.')
  800 FORMAT(1X,I3,2X,3(4X,E11.4,3X,I1,3X,I2))
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE GHMAT10(X,Y,G,H,KODE,N,NX,A1,B1,ISTEP,AT,CS,IAU)
C
C  THIS SUBROUTINE COMPUTES THE G AND H MATRICES AND
C  FORM THE MATRIX A1 OF THE SYSTEM OF EQUATIONS IN THE FIRST STEP.
C  H IS A SQUARE MATRIX (NxN); G IS RECTANGULAR (Nx3*NE)
C
      DIMENSION G(NX,1),H(NX,1),A1(NX,1),B1(NX,1),X(1),Y(1),KODE(1),
     &          HT(3),GT(3)

      NE=N/2
      NG=3*NE
      DO 30 J=1,N
      DO 30 I=1,N
      H(I,J)=0.0
   30 G(I,J)=0.0
      DO 40 J=N+1,NG
      DO 40 I=1,N
   40 G(I,J)=0.0
C
C  COMPUTE THE COEFFICIENTS OF G AND H MATRICES
C
      DO 120 I=1,N
      DO 80 J=1,NE
      J1=2*J-1
      J2=J1+1
      J3=J2+1
      IF(J3.GT.N) J3=1
C
C  AT ISTEP=1, CHECK WHETHER NODE I BELONGS TO J ELEMENT
C
      IF(ISTEP.EQ.1.AND.(I-J1)*(I-J2)*(I-J3).EQ.0) GO TO 60
C
C  CHECK IF THE WAVES HAVE ARRIVED FORM THE I-NODE TO THE J-ELEMENT
C
      DIST=DISTP(X(I),Y(I),X(J1),Y(J1),X(J2),Y(J2),X(J3),Y(J3))
      IF(DIST.GT.CS*ISTEP*AT) GO TO 80
      CALL EXTIN10(X(I),Y(I),X(J1),Y(J1),X(J2),Y(J2),X(J3),Y(J3),HT,GT,
     &             ISTEP,AT,CS)
      GO TO 70
   60 NODO=I-2*J+2
      IF(I.EQ.1.AND.J.EQ.NE) NODO=3
      CALL LOCIN10(X(I),Y(I),X(J1),Y(J1),X(J2),Y(J2),X(J3),Y(J3),NODO,
     &             AT,CS,HT,GT)
   70 H(I,J1)=H(I,J1)+HT(1)
      H(I,J2)=H(I,J2)+HT(2)
      H(I,J3)=H(I,J3)+HT(3)
      G(I,3*J-2)=GT(1)
      G(I,3*J-1)=GT(2)
      G(I,3*J  )=GT(3)
   80 CONTINUE
      IF(ISTEP.NE.1) GO TO 120
      CII=0.5
      IF(2*(I/2)-I .EQ. 0) GO TO 110
      I2=I-1
      IF(I.EQ.1) I2=N
      I1=I2-1
      CALL FTERM10(CII,X(I1),Y(I1),X(I2),Y(I2),X(I),Y(I),
     &                X(I+1),Y(I+1),X(I+2),Y(I+2))
  110 H(I,I)=H(I,I)+CII
  120 CONTINUE
C
C  WRITE THE MATRICES IN AN AUXILIARY FILE
C
      WRITE(IAU) ((H(I,J),I=1,N),J=1,N),((G(I,J),I=1,N),J=1,NG)
C
C  REORDER THE COLUMNS OF THE SYSTEM OF EQUATIONS IN ACCORDANCE WITH THE
C  BOUNDARY CONDITIONS AND FORM SYSTEM MATRIX WHICH IS STORED IN A1 IN
C  THE FIRST STEP
C
      IF(ISTEP.GT.1) RETURN
      DO 220 J=1,N
      JB=J+J/2-1
      IF(J.EQ.1) JB=NG
      JA=2*J-J/2-1
      KODEB=KODE(JB)
      KODEA=KODE(JA)
      IF(KODEB.EQ.0.OR.KODEA.EQ.0) GO TO 140
      DO 130 I=1,N
      A1(I,J)=H(I,J)
      B1(I,JB)=G(I,JB)
  130 B1(I,JA)=G(I,JA)
      GO TO 220
  140 IF(KODEB.EQ.1.OR.KODEA.EQ.1.OR.JB.NE.JA) GO TO 160
      DO 150 I=1,N
      A1(I,J)=-G(I,JB)
  150 B1(I,JB)=-H(I,J)
      GO TO 220
  160 IF(KODEB.EQ.1.OR.KODEA.EQ.1.OR.JB.EQ.JA) GO TO 180
      DO 170 I=1,N
      A1(I,J)=-(G(I,JB)+G(I,JA))
      B1(I,JB)=-H(I,J)
  170 B1(I,JA)=0.0
      GO TO 220
  180 IF(KODEB.EQ.1.OR.KODEA.EQ.0) GO TO 200
      DO 190 I=1,N
      A1(I,J)=-G(I,JB)
      B1(I,JB)=-H(I,J)
  190 B1(I,JA)=G(I,JA)
      GO TO 220
  200 IF(KODEB.EQ.0.OR.KODEA.EQ.1) GO TO 220
      DO 210 I=1,N
      A1(I,J)=-G(I,JA)
      B1(I,JB)=G(I,JB)
  210 B1(I,JA)=-H(I,J)
  220 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE EXTIN10(XP,YP,X1,Y1,X2,Y2,X3,Y3,HT,GT,ISTEP,AT,CS)
C
C  THIS SUBROUTINE COMPUTES THE G AND H MATRICES
C  COEFFICIENTS THAT RELATE A COLOCATION POINT WITH AN ELEMENT
C  USING GAUSS QUADRATURE
C
C  RA            = RADIUS
C  RDN           = RADIUS DERIVATIVE WITH RESPECT TO THE NORMAL
C  ETA1,ETA2     = COMPONENTS OF THE UNIT NORMAL TO THE ELEMENT
C  GI(I)         = GAUSS QUADRATURE POINTS
C  OME(I)        = GAUSS QUADRATURE WEIGHTS
C  XCO,YCO       = INTEGRATION POINTS ALONG THE ELEMENT
C
      DIMENSION GI(10),OME(10),HT(3),GT(3)
      DATA GI/0.9739065285,-0.9739065285,0.8650633666,-0.8650633666,
     &        0.6794095682,-0.6794095682,0.4333953941,-0.4333953941,
     &        0.1488743389,-0.1488743389/
      DATA OME/0.0666713443,0.0666713443,0.1494513491,0.1494513491,
     &         0.2190863625,0.2190863625,0.2692667193,0.2692667193,
     &         0.2955242247,0.2955242247/
      DO 10 I=1,3
      HT(I)=0.0
   10 GT(I)=0.0
      A=X3-2.*X2+X1
      B=(X3-X1)/2.0
      C=Y3-2.*Y2+Y1
      D=(Y3-Y1)/2.0
      CST=CS*AT*ISTEP
C
      DO 40 I=1,10
      F1=GI(I)*(GI(I)-1.)*0.5
      F2=1.-GI(I)**2
      F3=GI(I)*(GI(I)+1.)*0.5
      XCO=X1*F1+X2*F2+X3*F3-XP
      YCO=Y1*F1+Y2*F2+Y3*F3-YP
      RA=SQRT(XCO**2+YCO**2)
      IF(RA.GT.CST) GO TO 40
      CALL FUNDSOLS(G,H,RA,ISTEP,AT,CS)
      ETA1= (GI(I)*C+D)
      ETA2=-(GI(I)*A+B)
      XJA=SQRT(ETA1**2+ETA2**2)
      G=XJA*G*OME(I)
      GT(1)=GT(1)+F1*G
      GT(2)=GT(2)+F2*G
      GT(3)=GT(3)+F3*G
      RDN=(XCO*ETA1+YCO*ETA2)/RA
      H=RDN*H*OME(I)
      HT(1)=HT(1)+F1*H
      HT(2)=HT(2)+F2*H
      HT(3)=HT(3)+F3*H
   40 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE LOCIN10(XP,YP,X1,Y1,X2,Y2,X3,Y3,NODO,AT,CS,HT,GT)
C
C  THIS SUBROUTINE COMPUTES THE G AND H MATRICES WHEN THE COLLOCATION
C  POINT IS ONE OF THE NODES OF THE INTEGRATION ELEMENT.
C  THE COEFFICIENTS ARE COMPUTED BY NUMERICAL INTEGRATION:
C  THE NON-SINGULAR PART IS COMPUTED USING STANDARD GAUSS QUADRATURE,
C  THE LOGARITHMIC PART IS COMPUTED USING A SPECIAL QUADRATURE FORMULA.
C
      PARAMETER(PI2=6.2831853072)
      DIMENSION HT(3),GT(3),GI(10),OME(10),GIL(10),OMEL(10)
C
C  DATA FOR THE GAUSS QUADRATURE
C
      DATA GI/0.9739065285,-0.9739065285,0.8650633666,-0.8650633666,
     &        0.6794095682,-0.6794095682,0.4333953941,-0.4333953941,
     &        0.1488743389,-0.1488743389/
      DATA OME/0.0666713443,0.0666713443,0.1494513491,0.1494513491,
     &         0.2190863625,0.2190863625,0.2692667193,0.2692667193,
     &         0.2955242247,0.2955242247/
C
C  DATA FOR THE SPECIAL QUADRATURE
C
      DATA GIL/0.0090426309,0.0539712662,0.1353118246,0.2470524162,
     &         0.3802125396,0.5237923179,0.6657752055,0.7941904160,
     &         0.8981610912,0.9688479887/
      DATA OMEL/0.1209551319,0.1863635425,0.1956608732,0.1735771421,
     &          0.1356956729,0.0936467585,0.0557877273,0.0271598109,
     &          0.0095151826,0.0016381576/
      A=X3-2.*X2+X1
      B=(X3-X1)/2
      C=Y3-2.*Y2+Y1
      D=(Y3-Y1)/2
      GOTO(10,20,30),NODO
   10 A1=0.5
      A0=0.5
      XJAL=2.0
      GO TO 40
   20 A1=1.0
      A0=0.0
      XJAL=1.0
      GO TO 40
   30 A1=-0.5
      A0=0.5
      XJAL=2.0
   40 CST=CS*AT
      DO 50 I=1,3
      HT(I)=0.
   50 GT(I)=0.
C
      DO 70 I=1,10
      F1=0.5*GI(I)*(GI(I)-1.)
      F2=1.-GI(I)**2
      F3=0.5*GI(I)*(GI(I)+1.)
      XCO=X1*F1+X2*F2+X3*F3-XP
      YCO=Y1*F1+Y2*F2+Y3*F3-YP
      RA=SQRT(XCO*XCO+YCO*YCO)
      XJA=SQRT((GI(I)*A+B)**2+(GI(I)*C+D)**2)
      CALL FUNDSOLS(G,H,RA,1,AT,CS)
C
C  CALCULATE GT
C
      ETA=ABS(A1*GI(I)+A0)
      G=(G*PI2+ALOG(ETA))*XJA*OME(I)
      GIA=(GIL(I)-A0)/A1
      XJA=XJAL*SQRT((GIA*A+B)**2+(GIA*C+D)**2)*OMEL(I)
      S1=0.5*GIA*(GIA-1.)*XJA+F1*G
      S2=     (1.-GIA**2)*XJA+F2*G
      S3=0.5*GIA*(GIA+1.)*XJA+F3*G
      IF(NODO.NE.2) GO TO 60
      GIA=-GIL(I)
      XJA=XJAL*SQRT((GIA*A+B)**2+(GIA*C+D)**2)*OMEL(I)
      S1=S1+0.5*GIA*(GIA-1.)*XJA
      S2=S2+     (1.-GIA**2)*XJA
      S3=S3+0.5*GIA*(GIA+1.)*XJA
   60 GT(1)=GT(1)+S1/PI2
      GT(2)=GT(2)+S2/PI2
      GT(3)=GT(3)+S3/PI2
C
C  CALCULATE HT
C
      IF(RA.GE.CST) GO TO 70
      ETA1= (C*GI(I)+D)
      ETA2=-(A*GI(I)+B)
      RDN=(XCO*ETA1+YCO*ETA2)/RA
      H=RDN*H*OME(I)
      HT(1)=HT(1)+F1*H
      HT(2)=HT(2)+F2*H
      HT(3)=HT(3)+F3*H
   70 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE FTERM10(CII,X1,Y1,X2,Y2,X3,Y3,X4,Y4,X5,Y5)
C
C  THIS SUBROUTINE COMPUTES THE FREE TERMS OF MATRIX H
C
      PARAMETER (PI=3.1415926536)
      ZETA1=ATAN2(-0.5*X1+2.0*X2-1.5*X3, 0.5*Y1-2.0*Y2+1.5*Y3)
      ZETA2=ATAN2( 1.5*X3-2.0*X4+0.5*X5,-1.5*Y3+2.0*Y4-0.5*Y5)
      ZET=(ZETA2-ZETA1)/PI
      IF(ABS(ABS(ZET)-1.).LT.1E-4)
     &   STOP ' ERROR IN FREETERM10: COINCIDENT ELEMENTS'
      IF(INT(ZET)) 10,20,30
   10 CII=0.5*(-1-ZET)
      RETURN
   20 CII=0.5*(1-ZET)
      RETURN
   30 CII=0.5*(3-ZET)
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE FUNDSOLS(G,H,RA,ISTEP,AT,CS)
C
C  THIS SUBROUTINE COMPUTES THE FUNDAMENTAL SOLUTION
C
      PARAMETER(PI2=6.2831853072)
      RAIZ(X)=SQRT(X*X-1.0)
C
      G=0.0
      H=0.0
      A0=CS*ISTEP*AT/RA
      IF(A0.LE.1.0) RETURN
      A1=CS*(ISTEP-1)*AT/RA
      A2=CS*(ISTEP-2)*AT/RA
      IF(A1.GT.1.0) GO TO 10
      G=ALOG(A0+RAIZ(A0))/PI2
      H=-RAIZ(A0)/PI2/CS/AT
      RETURN
   10 IF(A2.GT.1.0) GO TO 20
      G=ALOG((A0+RAIZ(A0))/(A1+RAIZ(A1)))/PI2
      H=-((2-ISTEP)*(3*ISTEP-2)*(CS*AT/RA)**2+3.0)/
     &   (RAIZ(A0)+2.0*RAIZ(A1))/PI2/CS/AT
      RETURN
   20 G=ALOG((A0+RAIZ(A0))/(A1+RAIZ(A1)))/PI2
      H=-(2.0-2.0*(A0**2+A2**2-1.0)/(RAIZ(A0)*RAIZ(A2)+A0*A2))/
     &   (RAIZ(A0)+2.0*RAIZ(A1)+RAIZ(A2))/PI2/CS/AT
      RETURN
      END
C-----------------------------------------------------------------------
      FUNCTION DISTP(XP,YP,X1,Y1,X2,Y2,X3,Y3)
      D1=(XP-X1)**2+(YP-Y1)**2
      D2=(XP-X2)**2+(YP-Y2)**2
      D3=(XP-X3)**2+(YP-Y3)**2
      DISTP=0.98*SQRT(MIN(D1,D2,D3))
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE PREST10(G,H,B1,U,T,FI,BC,IFUNC,KODE,FSCALE,FUNC,NPOIF,
     &                   N,ISTEP,AT,IAU,NX,NX1,NFM,NPM)
C
C  THIS SUBROUTINE ADDS THE CONTRIBUTION OF PREVIOUS STEPS AND THE
C  CONTRIBUTION OF BOUNDARY CONDITION TO FORM THE RIGHT HAND SIDE VECTOR
C
      DIMENSION G(NX,1),H(NX,1),B1(NX,1),U(NX,1),T(NX1,1),FI(1),BC(1),
     &          IFUNC(1),KODE(1),FSCALE(1),FUNC(NFM,NPM,2),NPOIF(1)

      NE=N/2
      NG=3*NE
      DO 10 J=1,N
   10 FI(J)=0.0
      TIME=AT*ISTEP
      DO 100 J=1,N
      JB=J+J/2-1
      IF(J.EQ.1) JB=NG
      JA=2*J-J/2-1
      KODEB=KODE(JB)
      KODEA=KODE(JA)
      NF=IFUNC(JB)
      BCVALB=FUNCVAL(NF,TIME,BC(JB)*FSCALE(NF),NPOIF(NF),FUNC,NFM,NPM)
      BCVALA=BCVALB
      IF(JB.EQ.JA) GO TO 20
      NF=IFUNC(JA)
      BCVALA=FUNCVAL(NF,TIME,BC(JA)*FSCALE(NF),NPOIF(NF),FUNC,NFM,NPM)
   20 IF(KODEB.EQ.0.OR.KODEA.EQ.0.OR.JB.NE.JA) GO TO 30
      T(JB,ISTEP)=BCVALB
      BCVALA=0.0
      GO TO 80
   30 IF(KODEB.EQ.0.OR.KODEA.EQ.0.OR.JB.EQ.JA) GO TO 40
      T(JB,ISTEP)=BCVALB
      T(JA,ISTEP)=BCVALA
      GO TO 80
   40 IF(KODEB.EQ.1.OR.KODEA.EQ.1) GO TO 50
      IF(BCVALB.NE.BCVALA) STOP ' ERROR 1 IN BOUNDARY CONDITIONS'
      U(J,ISTEP)=BCVALB
      BCVALA=0.0
      GO TO 80
   50 IF(KODEB.EQ.1.OR.KODEA.EQ.0) GO TO 60
      U(J,ISTEP)=BCVALB
      T(JA,ISTEP)=BCVALA
      GO TO 80
   60 IF(KODEB.EQ.0.OR.KODEA.EQ.1) GO TO 70
      T(JB,ISTEP)=BCVALB
      U(J,ISTEP)=BCVALA
      GO TO 80
   70 STOP ' ERROR 2 IN BOUNDARY CONDITIONS'
   80 IF(BCVALB.EQ.0.0.AND.BCVALA.EQ.0.0) GO TO 100
      DO 90 I=1,N
   90 FI(I)=FI(I)+B1(I,JB)*BCVALB+B1(I,JA)*BCVALA
  100 CONTINUE
      IF(ISTEP.EQ.1) RETURN
      REWIND IAU
      READ(IAU)
      DO 140 IMAT=2,ISTEP
      READ(IAU) ((H(I,J),I=1,N),J=1,N),((G(I,J),I=1,N),J=1,NG)
      IUT=ISTEP-IMAT+1
      DO 120 J=1,N
      AUX =U(J,IUT)
      AUX1=T(J,IUT)
      IF(AUX.EQ.0.0.AND.AUX1.EQ.0.0) GO TO 120
      DO 110 I=1,N
  110 FI(I)=FI(I)-H(I,J)*AUX+G(I,J)*AUX1
  120 CONTINUE
      DO 140 J=N+1,NG
      AUX=T(J,IUT)
      IF(AUX.EQ.0.0) GO TO 140
      DO 130 I=1,N
  130 FI(I)=FI(I)+G(I,J)*AUX
  140 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      FUNCTION FUNCVAL(NF,TT,SCALE,NPOIN,FUNC,NFM,NPM)
      DIMENSION FUNC(NFM,NPM,2)
      FUNCVAL=FUNC(NF,1,2)*SCALE
      IF(SCALE.EQ.0.0) RETURN
      DO 10 I=1,NPOIN-1
      IF(TT.LT.FUNC(NF,I,1).OR.TT.GE.FUNC(NF,I+1,1)) GO TO 10
      FUNCVAL=SCALE*(FUNC(NF,I,2)+(FUNC(NF,I+1,2)-FUNC(NF,I,2))/
     &        (FUNC(NF,I+1,1)-FUNC(NF,I,1))*(TT-FUNC(NF,I,1)))
      RETURN
   10 CONTINUE
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE OUTPUT10(X,Y,FI,U,T,KODE,N,NX,NX1,ISTEP,INTIMP,
     &TIME,IPR)
C                                                                       
C  THIS SUBROUTINE PRINTS THE VALUES OF THE DISPLACEMENTS AND
C  TRACTIONS AT BOUNDARY NODES. IT ALSO PUTS THE CALCULATED VALUES AND
C  BOUNDARY CONDITION IN THEIR CORRESPONDING VECTORS
C
      DIMENSION FI(1),X(1),Y(1),U(NX,1),T(NX1,1),KODE(1)
      LOGICAL PRINTA
C
      NE=N/2
      NG=3*NE
      PRINTA=(ISTEP/INTIMP)*INTIMP.EQ.ISTEP.OR.ISTEP.EQ.1
      IF(PRINTA) WRITE(IPR,100) TIME
      DO 60 J=1,N
      JB=J+J/2-1
      IF(J.EQ.1) JB=NG
      JA=2*J-J/2-1
      KODEB=KODE(JB)
      KODEA=KODE(JA)
      IF(KODEB.EQ.0.OR.KODEA.EQ.0) GO TO 10
      U(J,ISTEP)=FI(J)
      GO TO 50
   10 IF(KODEB.EQ.1.OR.KODEA.EQ.1) GO TO 20
      T(JB,ISTEP)=FI(J)
      T(JA,ISTEP)=FI(J)
      GO TO 50
   20 IF(KODEB.EQ.1.OR.KODEA.EQ.0) GO TO 30
      T(JB,ISTEP)=FI(J)
      GO TO 50
   30 IF(KODEB.EQ.0.OR.KODEA.EQ.1) GO TO 40
      T(JA,ISTEP)=FI(J)
      GO TO 50
   40 STOP ' ERROR 3 IN BOUNDARY CONDITIONS'
   50 IF(PRINTA)
     &   WRITE(IPR,200) X(J),Y(J),U(J,ISTEP),T(JB,ISTEP),T(JA,ISTEP)
   60 CONTINUE
  100 FORMAT(' ',79('*')//,' RESULTS AT TIME = ',E12.5//
     &       '  BOUNDARY NODES'/56X,'POTENTIAL DERIVATIVE'/9X,'X',15X,
     &       'Y',12X,'POTENTIAL',6X,'BEFORE NODE',6X,'AFTER NODE'/)
  200 FORMAT(5(2X,E14.5))
      RETURN
      END
C-----------------------------------------------------------------------
      SUBROUTINE RSOLVER(A,B,N,NX,KKK)
C
      REAL A(NX,NX),B(NX),X,RDOT
C
C  A=L*U  FACTORIZATION
C
C  KKK=0 : ONLY FORWARD AND BACK SUSTITUTION
C  KKK=1 : FACTORIZATION AND FORWARD AND BACK SUSTITUTION
C
      IF(KKK.EQ.0) GO TO 30
      DO 20 K=1,N
      K1=K-1
      DO 10 I=K,N
   10 A(I,K)=A(I,K)-RDOT(K1,A(I,1),NX,A(1,K),1)
      X=A(K,K)
      IF(X.NE.0.) GOTO 15
      WRITE(6,*) ' SOLVER : STOP  SINGULARITY IN ROW ',K
      STOP ' SOLVER : STOP SINGULARITY '
   15 X=1./X
      DO 20 J=K+1,N
   20 A(K,J)=X*(A(K,J)-RDOT(K1,A(K,1),NX,A(1,J),1))
   30 CONTINUE
C
C  FORWARD AND BACK SUBSTITUTION    L*U*X=B
C
C  SOLVE  L*Y=B
C
      DO 40 I=1,N
      B(I)=-(RDOT((I-1),A(I,1),NX,B,1)+B(I))/A(I,I)
   40 CONTINUE
C
C  SOLVE  U*X=Y
C
      DO 50 I=N,1,-1
      B(I)=-(RDOT((N-I),A(I,I+1),NX,B(I+1),1)+B(I))
   50 CONTINUE
C
      RETURN
      END
C-----------------------------------------------------------------------
      FUNCTION RDOT(N,U,IUX,V,IVX)
C
C THIS FUNCTION MAKES THE REAL DOT PRODUCT OF TWO VECTORS
C
      REAL U(1),V(1)
C
      RDOT=0.
      IF(N.LE.0) RETURN
      IU=1
      IV=1
      IF(IUX.LT.0) IU=1-(N-1)*IUX
      IF(IVX.LT.0) IV=1-(N-1)*IVX
      DO 10 I=1,N
      RDOT=RDOT+U(IU)*V(IV)
      IU=IU+IUX
   10 IV=IV+IVX
      RETURN
      END
